/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20161210-64(RM)
 * Copyright (c) 2000 - 2016 Intel Corporation
 * 
 * Disassembling to non-symbolic legacy ASL operators
 *
 * Disassembly of SSDT-2-RVP3Rtd3.aml, Sat Jan 12 12:15:30 2019
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x00005492 (21650)
 *     Revision         0x02
 *     Checksum         0xAD
 *     OEM ID           "INTEL "
 *     OEM Table ID     "RVP3Rtd3"
 *     OEM Revision     0x00001000 (4096)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20160422 (538313762)
 */
DefinitionBlock ("", "SSDT", 2, "INTEL ", "RVP3Rtd3", 0x00001000)
{
    /*
     * iASL Warning: There were 29 external control methods found during
     * disassembly, but only 25 were resolved (4 unresolved). Additional
     * ACPI tables may be required to properly disassemble the code. This
     * resulting disassembler output file may not compile because the
     * disassembler did not know how many arguments to assign to the
     * unresolved methods. Note: SSDTs can be dynamically loaded at
     * runtime and may or may not be available via the host OS.
     *
     * To specify the tables needed to resolve external control method
     * references, the -e option can be used to specify the filenames.
     * Example iASL invocations:
     *     iasl -e ssdt1.aml ssdt2.aml ssdt3.aml -d dsdt.aml
     *     iasl -e dsdt.aml ssdt2.aml -d ssdt1.aml
     *     iasl -e ssdt*.aml -d dsdt.aml
     *
     * In addition, the -fe option can be used to specify a file containing
     * control method external declarations with the associated method
     * argument counts. Each line of the file must be of the form:
     *     External (<method pathname>, MethodObj, <argument count>)
     * Invocation:
     *     iasl -fe refs.txt -d dsdt.aml
     *
     * The following methods were unresolved and many not compile properly
     * because the disassembler had to guess at the number of arguments
     * required for each:
     */
    External (_SB_.GGOV, MethodObj)    // 1 Arguments (from opcode)
    External (_SB_.ICAM.IDFU, IntObj)    // (from opcode)
    External (_SB_.ICAM.IPWR, IntObj)    // (from opcode)
    External (_SB_.OSCO, UnknownObj)    // (from opcode)
    External (_SB_.PCI0, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.GEXP, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.GEXP.GEPS, MethodObj)    // 2 Arguments (from opcode)
    External (_SB_.PCI0.GEXP.SGEP, MethodObj)    // 3 Arguments (from opcode)
    External (_SB_.PCI0.GLAN, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.HDAS, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.HDAS.VDID, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.I2C0, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.I2C0.TPD0, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.I2C1, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.I2C1.TPL1, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.I2C1.TPL1._STA, MethodObj)    // 0 Arguments (from opcode)
    External (_SB_.PCI0.I2C1.TPL1.IC1D, UnknownObj)    // Warning: Unknown object
    External (_SB_.PCI0.LPCB.H_EC.ECAV, IntObj)    // (from opcode)
    External (_SB_.PCI0.LPCB.H_EC.PVOL, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.LPCB.H_EC.SPT2, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP01, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.RP01.DPGE, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP01.L23E, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP01.L23R, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP01.LASX, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP01.LDIS, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP01.LEDM, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP01.PCRA, MethodObj)    // 3 Arguments (from opcode)
    External (_SB_.PCI0.RP01.PCRO, MethodObj)    // 3 Arguments (from opcode)
    External (_SB_.PCI0.RP01.VDID, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP02, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.RP02.DPGE, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP02.L23E, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP02.L23R, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP02.LASX, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP02.LDIS, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP02.LEDM, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP02.VDID, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP03, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.RP03.DPGE, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP03.L23E, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP03.L23R, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP03.LASX, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP03.LDIS, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP03.LEDM, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP03.VDID, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP04, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.RP04.DPGE, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP04.L23E, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP04.L23R, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP04.LASX, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP04.LDIS, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP04.LEDM, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP04.VDID, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP05, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.RP05.DPGE, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP05.L23E, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP05.L23R, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP05.LASX, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP05.LDIS, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP05.LEDM, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP05.VDID, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP06, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.RP06.DPGE, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP06.L23E, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP06.L23R, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP06.LASX, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP06.LDIS, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP06.LEDM, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP06.PCRA, MethodObj)    // 3 Arguments (from opcode)
    External (_SB_.PCI0.RP06.PCRO, MethodObj)    // 3 Arguments (from opcode)
    External (_SB_.PCI0.RP06.VDID, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP07, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.RP07.DPGE, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP07.L23E, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP07.L23R, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP07.LASX, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP07.LDIS, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP07.LEDM, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP07.VDID, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP08, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.RP08.DPGE, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP08.L23E, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP08.L23R, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP08.LASX, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP08.LDIS, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP08.LEDM, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP08.PCRA, MethodObj)    // 3 Arguments (from opcode)
    External (_SB_.PCI0.RP08.PCRO, MethodObj)    // 3 Arguments (from opcode)
    External (_SB_.PCI0.RP08.PXSX, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.RP08.PXSX.PAHC, MethodObj)    // 0 Arguments (from opcode)
    External (_SB_.PCI0.RP08.PXSX.PNVM, MethodObj)    // 0 Arguments (from opcode)
    External (_SB_.PCI0.RP08.VDID, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP09, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.RP09.DPGE, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP09.L23E, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP09.L23R, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP09.LASX, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP09.LDIS, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP09.LEDM, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP09.PCRA, MethodObj)    // 3 Arguments (from opcode)
    External (_SB_.PCI0.RP09.PCRO, MethodObj)    // 3 Arguments (from opcode)
    External (_SB_.PCI0.RP09.VDID, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP10, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.RP10.DPGE, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP10.L23E, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP10.L23R, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP10.LASX, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP10.LDIS, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP10.LEDM, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP10.PCRA, MethodObj)    // 3 Arguments (from opcode)
    External (_SB_.PCI0.RP10.PCRO, MethodObj)    // 3 Arguments (from opcode)
    External (_SB_.PCI0.RP10.VDID, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP11, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.RP11.DPGE, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP11.L23E, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP11.L23R, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP11.LASX, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP11.LDIS, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP11.LEDM, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP11.VDID, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP12, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.RP12.DPGE, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP12.L23E, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP12.L23R, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP12.LASX, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP12.LDIS, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP12.LEDM, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP12.VDID, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP13, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.RP13.DPGE, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP13.L23E, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP13.L23R, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP13.LASX, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP13.LDIS, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP13.LEDM, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP13.VDID, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP14, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.RP14.DPGE, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP14.L23E, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP14.L23R, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP14.LASX, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP14.LDIS, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP14.LEDM, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP14.VDID, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP15, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.RP15.DPGE, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP15.L23E, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP15.L23R, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP15.LASX, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP15.LDIS, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP15.LEDM, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP15.VDID, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP16, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.RP16.DPGE, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP16.L23E, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP16.L23R, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP16.LASX, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP16.LDIS, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP16.LEDM, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP16.VDID, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP17, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.RP17.DPGE, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP17.L23E, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP17.L23R, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP17.LASX, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP17.LDIS, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP17.LEDM, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP17.VDID, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP18, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.RP18.DPGE, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP18.L23E, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP18.L23R, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP18.LASX, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP18.LDIS, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP18.LEDM, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP18.VDID, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP19, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.RP19.DPGE, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP19.L23E, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP19.L23R, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP19.LASX, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP19.LDIS, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP19.LEDM, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP19.VDID, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP20, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.RP20.DPGE, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP20.L23E, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP20.L23R, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP20.LASX, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP20.LDIS, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP20.LEDM, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.RP20.VDID, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.SAT0, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.SAT0.NVM1, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.SAT0.NVM2, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.SAT0.NVM2.RPOF, MethodObj)    // 0 Arguments (from opcode)
    External (_SB_.PCI0.SAT0.NVM2.RPON, MethodObj)    // 0 Arguments (from opcode)
    External (_SB_.PCI0.SAT0.NVM3, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.SAT0.POFF, MethodObj)    // 1 Arguments (from opcode)
    External (_SB_.PCI0.SAT0.PON_, MethodObj)    // 1 Arguments (from opcode)
    External (_SB_.PCI0.SAT0.PRT0, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.SAT0.PRT1, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.SAT0.PRT2, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.SAT0.PRT3, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.SAT0.PRT4, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.SAT0.PRT5, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.SAT0.PSTA, MethodObj)    // 1 Arguments (from opcode)
    External (_SB_.PCI0.XDCI, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.XDCI.D0I3, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.XDCI.XDCB, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.XHC_, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.XHC_.MEMB, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.XHC_.PMEE, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.XHC_.PMES, UnknownObj)    // (from opcode)
    External (_SB_.PCI0.XHC_.RHUB, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.XHC_.RHUB.HS01, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.XHC_.RHUB.HS02, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.XHC_.RHUB.HS03, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.XHC_.RHUB.HS04, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.XHC_.RHUB.HS05, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.XHC_.RHUB.HS10, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.XHC_.RHUB.HS11, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.XHC_.RHUB.SS01, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.XHC_.RHUB.SS02, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.XHC_.RHUB.SS03, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.XHC_.RHUB.SS04, DeviceObj)    // (from opcode)
    External (_SB_.PEPD, DeviceObj)    // (from opcode)
    External (_SB_.SGOV, MethodObj)    // 2 Arguments (from opcode)
    External (_SB_.SGRA, MethodObj)    // 2 Arguments (from opcode)
    External (_SB_.SHPO, MethodObj)    // 2 Arguments (from opcode)
    External (_SB_.WRGP, MethodObj)    // 2 Arguments (from opcode)
    External (_STA, UnknownObj)    // Warning: Unknown object
    External (AUDD, FieldUnitObj)    // (from opcode)
    External (CAMT, IntObj)    // (from opcode)
    External (DDSF, IntObj)    // (from opcode)
    External (DDSO, IntObj)    // (from opcode)
    External (DIVF, IntObj)    // (from opcode)
    External (DIVO, IntObj)    // (from opcode)
    External (DPGE, UnknownObj)    // Warning: Unknown object
    External (DVDG, UnknownObj)    // (from opcode)
    External (DVID, UnknownObj)    // (from opcode)
    External (ECON, IntObj)    // (from opcode)
    External (EMOD, IntObj)    // (from opcode)
    External (GBEP, UnknownObj)    // (from opcode)
    External (I20D, FieldUnitObj)    // (from opcode)
    External (I21D, FieldUnitObj)    // (from opcode)
    External (IC0D, FieldUnitObj)    // (from opcode)
    External (IC1D, FieldUnitObj)    // (from opcode)
    External (IC1S, FieldUnitObj)    // (from opcode)
    External (IVDG, UnknownObj)    // (from opcode)
    External (L23E, IntObj)    // Warning: Unknown object
    External (L23R, IntObj)    // Warning: Unknown object
    External (LASX, UnknownObj)    // Warning: Unknown object
    External (LDIS, UnknownObj)    // Warning: Unknown object
    External (LEDM, UnknownObj)    // Warning: Unknown object
    External (MEMB, UnknownObj)    // Warning: Unknown object
    External (NVM1, DeviceObj)    // Warning: Unknown object
    External (NVM2, DeviceObj)    // Warning: Unknown object
    External (NVM3, DeviceObj)    // Warning: Unknown object
    External (OSYS, UnknownObj)    // (from opcode)
    External (PAHC, IntObj)    // Warning: Unknown object
    External (PCHG, UnknownObj)    // (from opcode)
    External (PCHS, UnknownObj)    // (from opcode)
    External (PCRA, MethodObj)    // Warning: Unknown method, guessing 3 arguments
    External (PCRO, MethodObj)    // Warning: Unknown method, guessing 2 arguments
    External (PEP0, UnknownObj)    // (from opcode)
    External (PEP3, UnknownObj)    // (from opcode)
    External (PEPC, UnknownObj)    // (from opcode)
    External (PNVM, UnknownObj)    // Warning: Unknown object
    External (POFF, MethodObj)    // Warning: Unknown method, guessing 1 arguments
    External (PON_, MethodObj)    // Warning: Unknown method, guessing 1 arguments
    External (PRT0, DeviceObj)    // Warning: Unknown object
    External (PRT1, DeviceObj)    // Warning: Unknown object
    External (PRT2, DeviceObj)    // Warning: Unknown object
    External (PRT3, DeviceObj)    // Warning: Unknown object
    External (PRT4, DeviceObj)    // Warning: Unknown object
    External (PRT5, DeviceObj)    // Warning: Unknown object
    External (PSTA, IntObj)    // Warning: Unknown object
    External (RCG0, IntObj)    // (from opcode)
    External (RCG1, IntObj)    // (from opcode)
    External (RIC0, FieldUnitObj)    // (from opcode)
    External (RTD3, IntObj)    // (from opcode)
    External (S0ID, UnknownObj)    // (from opcode)
    External (SDS0, FieldUnitObj)    // (from opcode)
    External (SDS1, FieldUnitObj)    // (from opcode)
    External (SGMD, UnknownObj)    // (from opcode)
    External (SHSB, FieldUnitObj)    // (from opcode)
    External (SPST, IntObj)    // (from opcode)
    External (TPL1, DeviceObj)    // Warning: Unknown object
    External (UAMS, UnknownObj)    // (from opcode)
    External (VDID, UnknownObj)    // Warning: Unknown object
    External (VRRD, FieldUnitObj)    // (from opcode)
    External (VRSD, FieldUnitObj)    // (from opcode)
    External (WGUR, UnknownObj)    // (from opcode)
    External (XDCB, UnknownObj)    // Warning: Unknown object
    External (XDST, IntObj)    // (from opcode)
    External (XHPR, UnknownObj)    // (from opcode)

    If (LNotEqual (SGMD, 0x02))
    {
        Scope (\_SB.PCI0.RP01)
        {
            Name (SLOT, One)
            Name (RSTG, Package (0x04)
            {
                Zero, 
                Zero, 
                Zero, 
                Zero
            })
            Name (PWRG, Package (0x04)
            {
                Zero, 
                Zero, 
                Zero, 
                Zero
            })
            Name (WAKG, Package (0x04)
            {
                Zero, 
                Zero, 
                Zero, 
                Zero
            })
            Name (SCLK, Package (0x03)
            {
                Zero, 
                Zero, 
                Zero
            })
            Name (WKEN, Zero)
            Method (_S0W, 0, NotSerialized)  // _S0W: S0 Device Wake State
            {
                Return (0x03)
            }

            Method (_DSW, 3, NotSerialized)  // _DSW: Device Sleep Wake
            {
                If (Arg1)
                {
                    Store (Zero, WKEN)
                }
                ElseIf (LAnd (Arg0, Arg2))
                {
                    Store (One, WKEN)
                }
                Else
                {
                    Store (Zero, WKEN)
                }
            }

            PowerResource (PXP, 0x00, 0x0000)
            {
                Method (_STA, 0, NotSerialized)  // _STA: Status
                {
                    If (LEqual (\EMOD, One))
                    {
                        Return (One)
                    }
                    Else
                    {
                        Return (PSTA ())
                    }
                }

                Method (_ON, 0, NotSerialized)  // _ON_: Power On
                {
                    If (LEqual (\EMOD, One)) {}
                    Else
                    {
                        PON ()
                    }
                }

                Method (_OFF, 0, NotSerialized)  // _OFF: Power Off
                {
                    If (LEqual (\EMOD, One)) {}
                    Else
                    {
                        POFF ()
                    }
                }
            }

            Method (PSTA, 0, NotSerialized)
            {
                If (LEqual (VDID, 0xFFFFFFFF))
                {
                    Return (Zero)
                }

                If (LNotEqual (DerefOf (Index (PWRG, Zero)), Zero))
                {
                    If (LEqual (DerefOf (Index (PWRG, Zero)), One))
                    {
                        If (LEqual (\_SB.GGOV (DerefOf (Index (PWRG, 0x02))), DerefOf (Index (PWRG, 0x03))))
                        {
                            Return (One)
                        }
                        Else
                        {
                            Return (Zero)
                        }
                    }

                    If (LEqual (DerefOf (Index (PWRG, Zero)), 0x02))
                    {
                        If (LEqual (\_SB.PCI0.GEXP.GEPS (DerefOf (Index (PWRG, One)), DerefOf (Index (PWRG, 0x02))), DerefOf (Index (PWRG, 0x03))))
                        {
                            Return (One)
                        }
                        Else
                        {
                            Return (Zero)
                        }
                    }
                }

                If (LNotEqual (DerefOf (Index (RSTG, Zero)), Zero))
                {
                    If (LEqual (DerefOf (Index (RSTG, Zero)), One))
                    {
                        If (LEqual (\_SB.GGOV (DerefOf (Index (RSTG, 0x02))), DerefOf (Index (RSTG, 0x03))))
                        {
                            Return (One)
                        }
                        Else
                        {
                            Return (Zero)
                        }
                    }

                    If (LEqual (DerefOf (Index (RSTG, Zero)), 0x02))
                    {
                        If (LEqual (\_SB.PCI0.GEXP.GEPS (DerefOf (Index (RSTG, One)), DerefOf (Index (RSTG, 0x02))), DerefOf (Index (RSTG, 0x03))))
                        {
                            Return (One)
                        }
                        Else
                        {
                            Return (Zero)
                        }
                    }
                }

                Return (Zero)
            }

            Method (PON, 0, NotSerialized)
            {
                If (LEqual (VDID, 0xFFFFFFFF))
                {
                    Return (Zero)
                }

                If (LNotEqual (DerefOf (Index (PWRG, Zero)), Zero))
                {
                    If (LEqual (DerefOf (Index (PWRG, Zero)), One))
                    {
                        \_SB.SGOV (DerefOf (Index (PWRG, 0x02)), DerefOf (Index (PWRG, 0x03)))
                        Sleep (PEP0)
                    }

                    If (LEqual (DerefOf (Index (PWRG, Zero)), 0x02))
                    {
                        \_SB.PCI0.GEXP.SGEP (DerefOf (Index (PWRG, One)), DerefOf (Index (PWRG, 0x02)), DerefOf (Index (PWRG, 0x03)))
                        Sleep (PEP0)
                    }
                }

                If (LNotEqual (DerefOf (Index (SCLK, Zero)), Zero))
                {
                    PCRA (0xDC, 0x100C, Not (DerefOf (Index (SCLK, One))))
                    Sleep (0x10)
                }

                If (LNotEqual (DerefOf (Index (RSTG, Zero)), Zero))
                {
                    If (LEqual (DerefOf (Index (RSTG, Zero)), One))
                    {
                        \_SB.SGOV (DerefOf (Index (RSTG, 0x02)), DerefOf (Index (RSTG, 0x03)))
                    }

                    If (LEqual (DerefOf (Index (RSTG, Zero)), 0x02))
                    {
                        \_SB.PCI0.GEXP.SGEP (DerefOf (Index (RSTG, One)), DerefOf (Index (RSTG, 0x02)), DerefOf (Index (RSTG, 0x03)))
                    }
                }

                Store (Zero, DPGE)
                Store (One, L23R)
                Sleep (0x10)
                Store (Zero, Local0)
                While (L23R)
                {
                    If (LGreater (Local0, 0x04))
                    {
                        Break
                    }

                    Sleep (0x10)
                    Increment (Local0)
                }

                Store (One, DPGE)
                Store (Zero, Local0)
                While (LEqual (LASX, Zero))
                {
                    If (LGreater (Local0, 0x08))
                    {
                        Break
                    }

                    Sleep (0x10)
                    Increment (Local0)
                }

                Store (Zero, LEDM)
            }

            Method (POFF, 0, NotSerialized)
            {
                If (LEqual (VDID, 0xFFFFFFFF))
                {
                    Return (Zero)
                }

                Store (One, L23E)
                Sleep (0x10)
                Store (Zero, Local0)
                While (L23E)
                {
                    If (LGreater (Local0, 0x04))
                    {
                        Break
                    }

                    Sleep (0x10)
                    Increment (Local0)
                }

                Store (One, LEDM)
                If (LNotEqual (DerefOf (Index (RSTG, Zero)), Zero))
                {
                    If (LEqual (DerefOf (Index (RSTG, Zero)), One))
                    {
                        \_SB.SGOV (DerefOf (Index (RSTG, 0x02)), XOr (DerefOf (Index (RSTG, 0x03)), One))
                    }

                    If (LEqual (DerefOf (Index (RSTG, Zero)), 0x02))
                    {
                        \_SB.PCI0.GEXP.SGEP (DerefOf (Index (RSTG, One)), DerefOf (Index (RSTG, 0x02)), XOr (DerefOf (Index (RSTG, 0x03)), One))
                    }
                }

                If (LNotEqual (DerefOf (Index (SCLK, Zero)), Zero))
                {
                    PCRO (0xDC, 0x100C, DerefOf (Index (SCLK, One)))
                    Sleep (0x10)
                }

                If (LNotEqual (DerefOf (Index (PWRG, Zero)), Zero))
                {
                    If (LEqual (DerefOf (Index (PWRG, Zero)), One))
                    {
                        \_SB.SGOV (DerefOf (Index (PWRG, 0x02)), XOr (DerefOf (Index (PWRG, 0x03)), One))
                    }

                    If (LEqual (DerefOf (Index (PWRG, Zero)), 0x02))
                    {
                        \_SB.PCI0.GEXP.SGEP (DerefOf (Index (PWRG, One)), DerefOf (Index (PWRG, 0x02)), XOr (DerefOf (Index (PWRG, 0x03)), One))
                    }
                }

                Store (One, LDIS)
                Store (Zero, LDIS)
                If (WKEN)
                {
                    If (LNotEqual (DerefOf (Index (WAKG, Zero)), Zero))
                    {
                        If (LEqual (DerefOf (Index (WAKG, Zero)), One))
                        {
                            \_SB.SGOV (DerefOf (Index (WAKG, 0x02)), DerefOf (Index (WAKG, 0x03)))
                            \_SB.SHPO (DerefOf (Index (WAKG, 0x02)), Zero)
                        }

                        If (LEqual (DerefOf (Index (WAKG, Zero)), 0x02))
                        {
                            \_SB.PCI0.GEXP.SGEP (DerefOf (Index (WAKG, One)), DerefOf (Index (WAKG, 0x02)), DerefOf (Index (WAKG, 0x03)))
                        }
                    }
                }
            }

            Name (_PR0, Package (0x01)  // _PR0: Power Resources for D0
            {
                PXP
            })
        }
    }

    Scope (\_SB.PCI0.RP06)
    {
        Name (SLOT, 0x06)
        Name (RSTG, Package (0x04)
        {
            Zero, 
            Zero, 
            Zero, 
            Zero
        })
        Name (PWRG, Package (0x04)
        {
            Zero, 
            Zero, 
            Zero, 
            Zero
        })
        Name (WAKG, Package (0x04)
        {
            Zero, 
            Zero, 
            Zero, 
            Zero
        })
        Name (SCLK, Package (0x03)
        {
            Zero, 
            Zero, 
            Zero
        })
        Name (WKEN, Zero)
        Method (_S0W, 0, NotSerialized)  // _S0W: S0 Device Wake State
        {
            Return (0x03)
        }

        Method (_DSW, 3, NotSerialized)  // _DSW: Device Sleep Wake
        {
            If (Arg1)
            {
                Store (Zero, WKEN)
            }
            ElseIf (LAnd (Arg0, Arg2))
            {
                Store (One, WKEN)
            }
            Else
            {
                Store (Zero, WKEN)
            }
        }

        PowerResource (PXP, 0x00, 0x0000)
        {
            Method (_STA, 0, NotSerialized)  // _STA: Status
            {
                If (LEqual (\EMOD, One))
                {
                    Return (One)
                }
                Else
                {
                    Return (PSTA ())
                }
            }

            Method (_ON, 0, NotSerialized)  // _ON_: Power On
            {
                If (LEqual (\EMOD, One)) {}
                Else
                {
                    PON ()
                }
            }

            Method (_OFF, 0, NotSerialized)  // _OFF: Power Off
            {
                If (LEqual (\EMOD, One)) {}
                Else
                {
                    POFF ()
                }
            }
        }

        Method (PSTA, 0, NotSerialized)
        {
            If (LEqual (VDID, 0xFFFFFFFF))
            {
                Return (Zero)
            }

            If (LNotEqual (DerefOf (Index (PWRG, Zero)), Zero))
            {
                If (LEqual (DerefOf (Index (PWRG, Zero)), One))
                {
                    If (LEqual (\_SB.GGOV (DerefOf (Index (PWRG, 0x02))), DerefOf (Index (PWRG, 0x03))))
                    {
                        Return (One)
                    }
                    Else
                    {
                        Return (Zero)
                    }
                }

                If (LEqual (DerefOf (Index (PWRG, Zero)), 0x02))
                {
                    If (LEqual (\_SB.PCI0.GEXP.GEPS (DerefOf (Index (PWRG, One)), DerefOf (Index (PWRG, 0x02))), DerefOf (Index (PWRG, 0x03))))
                    {
                        Return (One)
                    }
                    Else
                    {
                        Return (Zero)
                    }
                }
            }

            If (LNotEqual (DerefOf (Index (RSTG, Zero)), Zero))
            {
                If (LEqual (DerefOf (Index (RSTG, Zero)), One))
                {
                    If (LEqual (\_SB.GGOV (DerefOf (Index (RSTG, 0x02))), DerefOf (Index (RSTG, 0x03))))
                    {
                        Return (One)
                    }
                    Else
                    {
                        Return (Zero)
                    }
                }

                If (LEqual (DerefOf (Index (RSTG, Zero)), 0x02))
                {
                    If (LEqual (\_SB.PCI0.GEXP.GEPS (DerefOf (Index (RSTG, One)), DerefOf (Index (RSTG, 0x02))), DerefOf (Index (RSTG, 0x03))))
                    {
                        Return (One)
                    }
                    Else
                    {
                        Return (Zero)
                    }
                }
            }

            Return (Zero)
        }

        Method (PON, 0, NotSerialized)
        {
            If (LEqual (VDID, 0xFFFFFFFF))
            {
                Return (Zero)
            }

            If (LNotEqual (DerefOf (Index (PWRG, Zero)), Zero))
            {
                If (LEqual (DerefOf (Index (PWRG, Zero)), One))
                {
                    \_SB.SGOV (DerefOf (Index (PWRG, 0x02)), DerefOf (Index (PWRG, 0x03)))
                    Sleep (PEP0)
                }

                If (LEqual (DerefOf (Index (PWRG, Zero)), 0x02))
                {
                    \_SB.PCI0.GEXP.SGEP (DerefOf (Index (PWRG, One)), DerefOf (Index (PWRG, 0x02)), DerefOf (Index (PWRG, 0x03)))
                    Sleep (PEP0)
                }
            }

            If (LNotEqual (DerefOf (Index (SCLK, Zero)), Zero))
            {
                PCRA (0xDC, 0x100C, Not (DerefOf (Index (SCLK, One))))
                Sleep (0x10)
            }

            If (LNotEqual (DerefOf (Index (RSTG, Zero)), Zero))
            {
                If (LEqual (DerefOf (Index (RSTG, Zero)), One))
                {
                    \_SB.SGOV (DerefOf (Index (RSTG, 0x02)), DerefOf (Index (RSTG, 0x03)))
                }

                If (LEqual (DerefOf (Index (RSTG, Zero)), 0x02))
                {
                    \_SB.PCI0.GEXP.SGEP (DerefOf (Index (RSTG, One)), DerefOf (Index (RSTG, 0x02)), DerefOf (Index (RSTG, 0x03)))
                }
            }

            Store (Zero, DPGE)
            Store (One, L23R)
            Sleep (0x10)
            Store (Zero, Local0)
            While (L23R)
            {
                If (LGreater (Local0, 0x04))
                {
                    Break
                }

                Sleep (0x10)
                Increment (Local0)
            }

            Store (One, DPGE)
            Store (Zero, Local0)
            While (LEqual (LASX, Zero))
            {
                If (LGreater (Local0, 0x08))
                {
                    Break
                }

                Sleep (0x10)
                Increment (Local0)
            }

            Store (Zero, LEDM)
        }

        Method (POFF, 0, NotSerialized)
        {
            If (LEqual (VDID, 0xFFFFFFFF))
            {
                Return (Zero)
            }

            Store (One, L23E)
            Sleep (0x10)
            Store (Zero, Local0)
            While (L23E)
            {
                If (LGreater (Local0, 0x04))
                {
                    Break
                }

                Sleep (0x10)
                Increment (Local0)
            }

            Store (One, LEDM)
            If (LNotEqual (DerefOf (Index (RSTG, Zero)), Zero))
            {
                If (LEqual (DerefOf (Index (RSTG, Zero)), One))
                {
                    \_SB.SGOV (DerefOf (Index (RSTG, 0x02)), XOr (DerefOf (Index (RSTG, 0x03)), One))
                }

                If (LEqual (DerefOf (Index (RSTG, Zero)), 0x02))
                {
                    \_SB.PCI0.GEXP.SGEP (DerefOf (Index (RSTG, One)), DerefOf (Index (RSTG, 0x02)), XOr (DerefOf (Index (RSTG, 0x03)), One))
                }
            }

            If (LNotEqual (DerefOf (Index (SCLK, Zero)), Zero))
            {
                PCRO (0xDC, 0x100C, DerefOf (Index (SCLK, One)))
                Sleep (0x10)
            }

            If (LNotEqual (DerefOf (Index (PWRG, Zero)), Zero))
            {
                If (LEqual (DerefOf (Index (PWRG, Zero)), One))
                {
                    \_SB.SGOV (DerefOf (Index (PWRG, 0x02)), XOr (DerefOf (Index (PWRG, 0x03)), One))
                }

                If (LEqual (DerefOf (Index (PWRG, Zero)), 0x02))
                {
                    \_SB.PCI0.GEXP.SGEP (DerefOf (Index (PWRG, One)), DerefOf (Index (PWRG, 0x02)), XOr (DerefOf (Index (PWRG, 0x03)), One))
                }
            }

            Store (One, LDIS)
            Store (Zero, LDIS)
            If (WKEN)
            {
                If (LNotEqual (DerefOf (Index (WAKG, Zero)), Zero))
                {
                    If (LEqual (DerefOf (Index (WAKG, Zero)), One))
                    {
                        \_SB.SGOV (DerefOf (Index (WAKG, 0x02)), DerefOf (Index (WAKG, 0x03)))
                        \_SB.SHPO (DerefOf (Index (WAKG, 0x02)), Zero)
                    }

                    If (LEqual (DerefOf (Index (WAKG, Zero)), 0x02))
                    {
                        \_SB.PCI0.GEXP.SGEP (DerefOf (Index (WAKG, One)), DerefOf (Index (WAKG, 0x02)), DerefOf (Index (WAKG, 0x03)))
                    }
                }
            }
        }

        Name (_PR0, Package (0x01)  // _PR0: Power Resources for D0
        {
            PXP
        })
    }

    Scope (\_SB.PCI0.RP08)
    {
        Name (SLOT, 0x08)
        Name (RSTG, Package (0x04)
        {
            Zero, 
            Zero, 
            Zero, 
            Zero
        })
        Name (PWRG, Package (0x04)
        {
            Zero, 
            Zero, 
            Zero, 
            Zero
        })
        Name (WAKG, Package (0x04)
        {
            Zero, 
            Zero, 
            Zero, 
            Zero
        })
        Name (SCLK, Package (0x03)
        {
            Zero, 
            Zero, 
            Zero
        })
        Name (WKEN, Zero)
        Method (_S0W, 0, NotSerialized)  // _S0W: S0 Device Wake State
        {
            Return (0x03)
        }

        Method (_DSW, 3, NotSerialized)  // _DSW: Device Sleep Wake
        {
            If (Arg1)
            {
                Store (Zero, WKEN)
            }
            ElseIf (LAnd (Arg0, Arg2))
            {
                Store (One, WKEN)
            }
            Else
            {
                Store (Zero, WKEN)
            }
        }

        PowerResource (PXP, 0x00, 0x0000)
        {
            Method (_STA, 0, NotSerialized)  // _STA: Status
            {
                If (LEqual (\EMOD, One))
                {
                    Return (One)
                }
                Else
                {
                    Return (PSTA ())
                }
            }

            Method (_ON, 0, NotSerialized)  // _ON_: Power On
            {
                If (LEqual (\EMOD, One)) {}
                Else
                {
                    PON ()
                }
            }

            Method (_OFF, 0, NotSerialized)  // _OFF: Power Off
            {
                If (LEqual (\EMOD, One)) {}
                Else
                {
                    POFF ()
                }
            }
        }

        Method (PSTA, 0, NotSerialized)
        {
            If (LEqual (VDID, 0xFFFFFFFF))
            {
                Return (Zero)
            }

            If (LNotEqual (DerefOf (Index (PWRG, Zero)), Zero))
            {
                If (LEqual (DerefOf (Index (PWRG, Zero)), One))
                {
                    If (LEqual (\_SB.GGOV (DerefOf (Index (PWRG, 0x02))), DerefOf (Index (PWRG, 0x03))))
                    {
                        Return (One)
                    }
                    Else
                    {
                        Return (Zero)
                    }
                }

                If (LEqual (DerefOf (Index (PWRG, Zero)), 0x02))
                {
                    If (LEqual (\_SB.PCI0.GEXP.GEPS (DerefOf (Index (PWRG, One)), DerefOf (Index (PWRG, 0x02))), DerefOf (Index (PWRG, 0x03))))
                    {
                        Return (One)
                    }
                    Else
                    {
                        Return (Zero)
                    }
                }
            }

            If (LNotEqual (DerefOf (Index (RSTG, Zero)), Zero))
            {
                If (LEqual (DerefOf (Index (RSTG, Zero)), One))
                {
                    If (LEqual (\_SB.GGOV (DerefOf (Index (RSTG, 0x02))), DerefOf (Index (RSTG, 0x03))))
                    {
                        Return (One)
                    }
                    Else
                    {
                        Return (Zero)
                    }
                }

                If (LEqual (DerefOf (Index (RSTG, Zero)), 0x02))
                {
                    If (LEqual (\_SB.PCI0.GEXP.GEPS (DerefOf (Index (RSTG, One)), DerefOf (Index (RSTG, 0x02))), DerefOf (Index (RSTG, 0x03))))
                    {
                        Return (One)
                    }
                    Else
                    {
                        Return (Zero)
                    }
                }
            }

            Return (Zero)
        }

        Method (PON, 0, NotSerialized)
        {
            If (LEqual (VDID, 0xFFFFFFFF))
            {
                Return (Zero)
            }

            If (LNotEqual (DerefOf (Index (PWRG, Zero)), Zero))
            {
                If (LEqual (DerefOf (Index (PWRG, Zero)), One))
                {
                    \_SB.SGOV (DerefOf (Index (PWRG, 0x02)), DerefOf (Index (PWRG, 0x03)))
                    Sleep (PEP0)
                }

                If (LEqual (DerefOf (Index (PWRG, Zero)), 0x02))
                {
                    \_SB.PCI0.GEXP.SGEP (DerefOf (Index (PWRG, One)), DerefOf (Index (PWRG, 0x02)), DerefOf (Index (PWRG, 0x03)))
                    Sleep (PEP0)
                }
            }

            If (LNotEqual (DerefOf (Index (SCLK, Zero)), Zero))
            {
                PCRA (0xDC, 0x100C, Not (DerefOf (Index (SCLK, One))))
                Sleep (0x10)
            }

            If (LNotEqual (DerefOf (Index (RSTG, Zero)), Zero))
            {
                If (LEqual (DerefOf (Index (RSTG, Zero)), One))
                {
                    \_SB.SGOV (DerefOf (Index (RSTG, 0x02)), DerefOf (Index (RSTG, 0x03)))
                }

                If (LEqual (DerefOf (Index (RSTG, Zero)), 0x02))
                {
                    \_SB.PCI0.GEXP.SGEP (DerefOf (Index (RSTG, One)), DerefOf (Index (RSTG, 0x02)), DerefOf (Index (RSTG, 0x03)))
                }
            }

            Store (Zero, DPGE)
            Store (One, L23R)
            Sleep (0x10)
            Store (Zero, Local0)
            While (L23R)
            {
                If (LGreater (Local0, 0x04))
                {
                    Break
                }

                Sleep (0x10)
                Increment (Local0)
            }

            Store (One, DPGE)
            Store (Zero, Local0)
            While (LEqual (LASX, Zero))
            {
                If (LGreater (Local0, 0x08))
                {
                    Break
                }

                Sleep (0x10)
                Increment (Local0)
            }

            Store (Zero, LEDM)
        }

        Method (POFF, 0, NotSerialized)
        {
            If (LEqual (VDID, 0xFFFFFFFF))
            {
                Return (Zero)
            }

            Store (One, L23E)
            Sleep (0x10)
            Store (Zero, Local0)
            While (L23E)
            {
                If (LGreater (Local0, 0x04))
                {
                    Break
                }

                Sleep (0x10)
                Increment (Local0)
            }

            Store (One, LEDM)
            If (LNotEqual (DerefOf (Index (RSTG, Zero)), Zero))
            {
                If (LEqual (DerefOf (Index (RSTG, Zero)), One))
                {
                    \_SB.SGOV (DerefOf (Index (RSTG, 0x02)), XOr (DerefOf (Index (RSTG, 0x03)), One))
                }

                If (LEqual (DerefOf (Index (RSTG, Zero)), 0x02))
                {
                    \_SB.PCI0.GEXP.SGEP (DerefOf (Index (RSTG, One)), DerefOf (Index (RSTG, 0x02)), XOr (DerefOf (Index (RSTG, 0x03)), One))
                }
            }

            If (LNotEqual (DerefOf (Index (SCLK, Zero)), Zero))
            {
                PCRO (0xDC, 0x100C, DerefOf (Index (SCLK, One)))
                Sleep (0x10)
            }

            If (LNotEqual (DerefOf (Index (PWRG, Zero)), Zero))
            {
                If (LEqual (DerefOf (Index (PWRG, Zero)), One))
                {
                    \_SB.SGOV (DerefOf (Index (PWRG, 0x02)), XOr (DerefOf (Index (PWRG, 0x03)), One))
                }

                If (LEqual (DerefOf (Index (PWRG, Zero)), 0x02))
                {
                    \_SB.PCI0.GEXP.SGEP (DerefOf (Index (PWRG, One)), DerefOf (Index (PWRG, 0x02)), XOr (DerefOf (Index (PWRG, 0x03)), One))
                }
            }

            Store (One, LDIS)
            Store (Zero, LDIS)
            If (WKEN)
            {
                If (LNotEqual (DerefOf (Index (WAKG, Zero)), Zero))
                {
                    If (LEqual (DerefOf (Index (WAKG, Zero)), One))
                    {
                        \_SB.SGOV (DerefOf (Index (WAKG, 0x02)), DerefOf (Index (WAKG, 0x03)))
                        \_SB.SHPO (DerefOf (Index (WAKG, 0x02)), Zero)
                    }

                    If (LEqual (DerefOf (Index (WAKG, Zero)), 0x02))
                    {
                        \_SB.PCI0.GEXP.SGEP (DerefOf (Index (WAKG, One)), DerefOf (Index (WAKG, 0x02)), DerefOf (Index (WAKG, 0x03)))
                    }
                }
            }
        }

        Name (_PR0, Package (0x01)  // _PR0: Power Resources for D0
        {
            PXP
        })
    }

    Scope (\_SB.PCI0.RP08.PXSX)
    {
        Name (_S0W, 0x04)  // _S0W: S0 Device Wake State
        Method (_PR0, 0, NotSerialized)  // _PR0: Power Resources for D0
        {
            If (LOr (PAHC (), PNVM ()))
            {
                If (LAnd (LGreaterEqual (\OSYS, 0x07DF), LEqual (\EMOD, One)))
                {
                    If (CondRefOf (\_SB.MODS))
                    {
                        Return (Package (0x01)
                        {
                            \_SB.MODS
                        })
                    }
                }
                ElseIf (CondRefOf (\_SB.PCI0.RP08.PXP))
                {
                    Return (Package (0x01)
                    {
                        \_SB.PCI0.RP08.PXP
                    })
                }
            }

            Return (Package (0x00) {})
        }

        Method (_PR3, 0, NotSerialized)  // _PR3: Power Resources for D3hot
        {
            If (LOr (PAHC (), PNVM ()))
            {
                If (LAnd (LGreaterEqual (\OSYS, 0x07DF), LEqual (\EMOD, One)))
                {
                    If (CondRefOf (\_SB.MODS))
                    {
                        Return (Package (0x01)
                        {
                            \_SB.MODS
                        })
                    }
                }
                ElseIf (CondRefOf (\_SB.PCI0.RP08.PXP))
                {
                    Return (Package (0x01)
                    {
                        \_SB.PCI0.RP08.PXP
                    })
                }
            }

            Return (Package (0x00) {})
        }

        Method (_PS0, 0, Serialized)  // _PS0: Power State 0
        {
        }

        Method (_PS3, 0, Serialized)  // _PS3: Power State 3
        {
        }

        Device (MINI)
        {
            Method (_STA, 0, Serialized)  // _STA: Status
            {
                If (PAHC ())
                {
                    Return (0x0F)
                }
                Else
                {
                    Return (Zero)
                }
            }

            Name (_ADR, 0xFFFF)  // _ADR: Address
            Name (_S0W, 0x04)  // _S0W: S0 Device Wake State
            Method (_PS0, 0, Serialized)  // _PS0: Power State 0
            {
            }

            Method (_PS3, 0, Serialized)  // _PS3: Power State 3
            {
            }

            Method (_PR0, 0, NotSerialized)  // _PR0: Power Resources for D0
            {
                If (PAHC ())
                {
                    If (LAnd (LGreaterEqual (\OSYS, 0x07DF), LEqual (\EMOD, One)))
                    {
                        If (CondRefOf (\_SB.MODS))
                        {
                            Return (Package (0x01)
                            {
                                \_SB.MODS
                            })
                        }
                    }
                    ElseIf (CondRefOf (\_SB.PCI0.RP08.PXP))
                    {
                        Return (Package (0x01)
                        {
                            \_SB.PCI0.RP08.PXP
                        })
                    }
                }

                Return (Package (0x00) {})
            }

            Method (_PR3, 0, NotSerialized)  // _PR3: Power Resources for D3hot
            {
                If (PAHC ())
                {
                    If (LAnd (LGreaterEqual (\OSYS, 0x07DF), LEqual (\EMOD, One)))
                    {
                        If (CondRefOf (\_SB.MODS))
                        {
                            Return (Package (0x01)
                            {
                                \_SB.MODS
                            })
                        }
                    }
                    ElseIf (CondRefOf (\_SB.PCI0.RP08.PXP))
                    {
                        Return (Package (0x01)
                        {
                            \_SB.PCI0.RP08.PXP
                        })
                    }
                }

                Return (Package (0x00) {})
            }
        }
    }

    Scope (\_SB.PCI0.RP09)
    {
        Name (SLOT, 0x09)
        Name (RSTG, Package (0x04)
        {
            One, 
            Zero, 
            0x0202000A, 
            One
        })
        Name (PWRG, Package (0x04)
        {
            Zero, 
            Zero, 
            Zero, 
            Zero
        })
        Name (WAKG, Package (0x04)
        {
            Zero, 
            Zero, 
            Zero, 
            Zero
        })
        Name (SCLK, Package (0x03)
        {
            One, 
            0x20, 
            Zero
        })
        Name (WKEN, Zero)
        Method (_S0W, 0, NotSerialized)  // _S0W: S0 Device Wake State
        {
            Return (0x03)
        }

        Method (_DSW, 3, NotSerialized)  // _DSW: Device Sleep Wake
        {
            If (Arg1)
            {
                Store (Zero, WKEN)
            }
            ElseIf (LAnd (Arg0, Arg2))
            {
                Store (One, WKEN)
            }
            Else
            {
                Store (Zero, WKEN)
            }
        }

        PowerResource (PXP, 0x00, 0x0000)
        {
            Method (_STA, 0, NotSerialized)  // _STA: Status
            {
                If (LEqual (\EMOD, One))
                {
                    Return (One)
                }
                Else
                {
                    Return (PSTA ())
                }
            }

            Method (_ON, 0, NotSerialized)  // _ON_: Power On
            {
                If (LEqual (\EMOD, One)) {}
                Else
                {
                    PON ()
                }
            }

            Method (_OFF, 0, NotSerialized)  // _OFF: Power Off
            {
                If (LEqual (\EMOD, One)) {}
                Else
                {
                    POFF ()
                }
            }
        }

        Method (PSTA, 0, NotSerialized)
        {
            If (LEqual (VDID, 0xFFFFFFFF))
            {
                Return (Zero)
            }

            If (LNotEqual (DerefOf (Index (PWRG, Zero)), Zero))
            {
                If (LEqual (DerefOf (Index (PWRG, Zero)), One))
                {
                    If (LEqual (\_SB.GGOV (DerefOf (Index (PWRG, 0x02))), DerefOf (Index (PWRG, 0x03))))
                    {
                        Return (One)
                    }
                    Else
                    {
                        Return (Zero)
                    }
                }

                If (LEqual (DerefOf (Index (PWRG, Zero)), 0x02))
                {
                    If (LEqual (\_SB.PCI0.GEXP.GEPS (DerefOf (Index (PWRG, One)), DerefOf (Index (PWRG, 0x02))), DerefOf (Index (PWRG, 0x03))))
                    {
                        Return (One)
                    }
                    Else
                    {
                        Return (Zero)
                    }
                }
            }

            If (LNotEqual (DerefOf (Index (RSTG, Zero)), Zero))
            {
                If (LEqual (DerefOf (Index (RSTG, Zero)), One))
                {
                    If (LEqual (\_SB.GGOV (DerefOf (Index (RSTG, 0x02))), DerefOf (Index (RSTG, 0x03))))
                    {
                        Return (One)
                    }
                    Else
                    {
                        Return (Zero)
                    }
                }

                If (LEqual (DerefOf (Index (RSTG, Zero)), 0x02))
                {
                    If (LEqual (\_SB.PCI0.GEXP.GEPS (DerefOf (Index (RSTG, One)), DerefOf (Index (RSTG, 0x02))), DerefOf (Index (RSTG, 0x03))))
                    {
                        Return (One)
                    }
                    Else
                    {
                        Return (Zero)
                    }
                }
            }

            Return (Zero)
        }

        Method (PON, 0, NotSerialized)
        {
            If (LEqual (VDID, 0xFFFFFFFF))
            {
                Return (Zero)
            }

            If (LNotEqual (DerefOf (Index (PWRG, Zero)), Zero))
            {
                If (LEqual (DerefOf (Index (PWRG, Zero)), One))
                {
                    \_SB.SGOV (DerefOf (Index (PWRG, 0x02)), DerefOf (Index (PWRG, 0x03)))
                    Sleep (PEP0)
                }

                If (LEqual (DerefOf (Index (PWRG, Zero)), 0x02))
                {
                    \_SB.PCI0.GEXP.SGEP (DerefOf (Index (PWRG, One)), DerefOf (Index (PWRG, 0x02)), DerefOf (Index (PWRG, 0x03)))
                    Sleep (PEP0)
                }
            }

            If (LNotEqual (DerefOf (Index (SCLK, Zero)), Zero))
            {
                PCRA (0xDC, 0x100C, Not (DerefOf (Index (SCLK, One))))
                Sleep (0x10)
            }

            If (LNotEqual (DerefOf (Index (RSTG, Zero)), Zero))
            {
                If (LEqual (DerefOf (Index (RSTG, Zero)), One))
                {
                    \_SB.SGOV (DerefOf (Index (RSTG, 0x02)), DerefOf (Index (RSTG, 0x03)))
                }

                If (LEqual (DerefOf (Index (RSTG, Zero)), 0x02))
                {
                    \_SB.PCI0.GEXP.SGEP (DerefOf (Index (RSTG, One)), DerefOf (Index (RSTG, 0x02)), DerefOf (Index (RSTG, 0x03)))
                }
            }

            Store (Zero, DPGE)
            Store (One, L23R)
            Sleep (0x10)
            Store (Zero, Local0)
            While (L23R)
            {
                If (LGreater (Local0, 0x04))
                {
                    Break
                }

                Sleep (0x10)
                Increment (Local0)
            }

            Store (One, DPGE)
            Store (Zero, Local0)
            While (LEqual (LASX, Zero))
            {
                If (LGreater (Local0, 0x08))
                {
                    Break
                }

                Sleep (0x10)
                Increment (Local0)
            }

            Store (Zero, LEDM)
        }

        Method (POFF, 0, NotSerialized)
        {
            If (LEqual (VDID, 0xFFFFFFFF))
            {
                Return (Zero)
            }

            Store (One, L23E)
            Sleep (0x10)
            Store (Zero, Local0)
            While (L23E)
            {
                If (LGreater (Local0, 0x04))
                {
                    Break
                }

                Sleep (0x10)
                Increment (Local0)
            }

            Store (One, LEDM)
            If (LNotEqual (DerefOf (Index (RSTG, Zero)), Zero))
            {
                If (LEqual (DerefOf (Index (RSTG, Zero)), One))
                {
                    \_SB.SGOV (DerefOf (Index (RSTG, 0x02)), XOr (DerefOf (Index (RSTG, 0x03)), One))
                }

                If (LEqual (DerefOf (Index (RSTG, Zero)), 0x02))
                {
                    \_SB.PCI0.GEXP.SGEP (DerefOf (Index (RSTG, One)), DerefOf (Index (RSTG, 0x02)), XOr (DerefOf (Index (RSTG, 0x03)), One))
                }
            }

            If (LNotEqual (DerefOf (Index (SCLK, Zero)), Zero))
            {
                PCRO (0xDC, 0x100C, DerefOf (Index (SCLK, One)))
                Sleep (0x10)
            }

            If (LNotEqual (DerefOf (Index (PWRG, Zero)), Zero))
            {
                If (LEqual (DerefOf (Index (PWRG, Zero)), One))
                {
                    \_SB.SGOV (DerefOf (Index (PWRG, 0x02)), XOr (DerefOf (Index (PWRG, 0x03)), One))
                }

                If (LEqual (DerefOf (Index (PWRG, Zero)), 0x02))
                {
                    \_SB.PCI0.GEXP.SGEP (DerefOf (Index (PWRG, One)), DerefOf (Index (PWRG, 0x02)), XOr (DerefOf (Index (PWRG, 0x03)), One))
                }
            }

            Store (One, LDIS)
            Store (Zero, LDIS)
            If (WKEN)
            {
                If (LNotEqual (DerefOf (Index (WAKG, Zero)), Zero))
                {
                    If (LEqual (DerefOf (Index (WAKG, Zero)), One))
                    {
                        \_SB.SGOV (DerefOf (Index (WAKG, 0x02)), DerefOf (Index (WAKG, 0x03)))
                        \_SB.SHPO (DerefOf (Index (WAKG, 0x02)), Zero)
                    }

                    If (LEqual (DerefOf (Index (WAKG, Zero)), 0x02))
                    {
                        \_SB.PCI0.GEXP.SGEP (DerefOf (Index (WAKG, One)), DerefOf (Index (WAKG, 0x02)), DerefOf (Index (WAKG, 0x03)))
                    }
                }
            }
        }

        Name (_PR0, Package (0x01)  // _PR0: Power Resources for D0
        {
            PXP
        })
    }

    Scope (\_SB.PCI0.RP10)
    {
        Name (SLOT, 0x0A)
        Name (RSTG, Package (0x04)
        {
            Zero, 
            Zero, 
            Zero, 
            Zero
        })
        Name (PWRG, Package (0x04)
        {
            Zero, 
            Zero, 
            Zero, 
            Zero
        })
        Name (WAKG, Package (0x04)
        {
            Zero, 
            Zero, 
            Zero, 
            Zero
        })
        Name (SCLK, Package (0x03)
        {
            Zero, 
            Zero, 
            Zero
        })
        Name (WKEN, Zero)
        Method (_S0W, 0, NotSerialized)  // _S0W: S0 Device Wake State
        {
            Return (0x03)
        }

        Method (_DSW, 3, NotSerialized)  // _DSW: Device Sleep Wake
        {
            If (Arg1)
            {
                Store (Zero, WKEN)
            }
            ElseIf (LAnd (Arg0, Arg2))
            {
                Store (One, WKEN)
            }
            Else
            {
                Store (Zero, WKEN)
            }
        }

        PowerResource (PXP, 0x00, 0x0000)
        {
            Method (_STA, 0, NotSerialized)  // _STA: Status
            {
                If (LEqual (\EMOD, One))
                {
                    Return (One)
                }
                Else
                {
                    Return (PSTA ())
                }
            }

            Method (_ON, 0, NotSerialized)  // _ON_: Power On
            {
                If (LEqual (\EMOD, One)) {}
                Else
                {
                    PON ()
                }
            }

            Method (_OFF, 0, NotSerialized)  // _OFF: Power Off
            {
                If (LEqual (\EMOD, One)) {}
                Else
                {
                    POFF ()
                }
            }
        }

        Method (PSTA, 0, NotSerialized)
        {
            If (LEqual (VDID, 0xFFFFFFFF))
            {
                Return (Zero)
            }

            If (LNotEqual (DerefOf (Index (PWRG, Zero)), Zero))
            {
                If (LEqual (DerefOf (Index (PWRG, Zero)), One))
                {
                    If (LEqual (\_SB.GGOV (DerefOf (Index (PWRG, 0x02))), DerefOf (Index (PWRG, 0x03))))
                    {
                        Return (One)
                    }
                    Else
                    {
                        Return (Zero)
                    }
                }

                If (LEqual (DerefOf (Index (PWRG, Zero)), 0x02))
                {
                    If (LEqual (\_SB.PCI0.GEXP.GEPS (DerefOf (Index (PWRG, One)), DerefOf (Index (PWRG, 0x02))), DerefOf (Index (PWRG, 0x03))))
                    {
                        Return (One)
                    }
                    Else
                    {
                        Return (Zero)
                    }
                }
            }

            If (LNotEqual (DerefOf (Index (RSTG, Zero)), Zero))
            {
                If (LEqual (DerefOf (Index (RSTG, Zero)), One))
                {
                    If (LEqual (\_SB.GGOV (DerefOf (Index (RSTG, 0x02))), DerefOf (Index (RSTG, 0x03))))
                    {
                        Return (One)
                    }
                    Else
                    {
                        Return (Zero)
                    }
                }

                If (LEqual (DerefOf (Index (RSTG, Zero)), 0x02))
                {
                    If (LEqual (\_SB.PCI0.GEXP.GEPS (DerefOf (Index (RSTG, One)), DerefOf (Index (RSTG, 0x02))), DerefOf (Index (RSTG, 0x03))))
                    {
                        Return (One)
                    }
                    Else
                    {
                        Return (Zero)
                    }
                }
            }

            Return (Zero)
        }

        Method (PON, 0, NotSerialized)
        {
            If (LEqual (VDID, 0xFFFFFFFF))
            {
                Return (Zero)
            }

            If (LNotEqual (DerefOf (Index (PWRG, Zero)), Zero))
            {
                If (LEqual (DerefOf (Index (PWRG, Zero)), One))
                {
                    \_SB.SGOV (DerefOf (Index (PWRG, 0x02)), DerefOf (Index (PWRG, 0x03)))
                    Sleep (PEP0)
                }

                If (LEqual (DerefOf (Index (PWRG, Zero)), 0x02))
                {
                    \_SB.PCI0.GEXP.SGEP (DerefOf (Index (PWRG, One)), DerefOf (Index (PWRG, 0x02)), DerefOf (Index (PWRG, 0x03)))
                    Sleep (PEP0)
                }
            }

            If (LNotEqual (DerefOf (Index (SCLK, Zero)), Zero))
            {
                PCRA (0xDC, 0x100C, Not (DerefOf (Index (SCLK, One))))
                Sleep (0x10)
            }

            If (LNotEqual (DerefOf (Index (RSTG, Zero)), Zero))
            {
                If (LEqual (DerefOf (Index (RSTG, Zero)), One))
                {
                    \_SB.SGOV (DerefOf (Index (RSTG, 0x02)), DerefOf (Index (RSTG, 0x03)))
                }

                If (LEqual (DerefOf (Index (RSTG, Zero)), 0x02))
                {
                    \_SB.PCI0.GEXP.SGEP (DerefOf (Index (RSTG, One)), DerefOf (Index (RSTG, 0x02)), DerefOf (Index (RSTG, 0x03)))
                }
            }

            Store (Zero, DPGE)
            Store (One, L23R)
            Sleep (0x10)
            Store (Zero, Local0)
            While (L23R)
            {
                If (LGreater (Local0, 0x04))
                {
                    Break
                }

                Sleep (0x10)
                Increment (Local0)
            }

            Store (One, DPGE)
            Store (Zero, Local0)
            While (LEqual (LASX, Zero))
            {
                If (LGreater (Local0, 0x08))
                {
                    Break
                }

                Sleep (0x10)
                Increment (Local0)
            }

            Store (Zero, LEDM)
        }

        Method (POFF, 0, NotSerialized)
        {
            If (LEqual (VDID, 0xFFFFFFFF))
            {
                Return (Zero)
            }

            Store (One, L23E)
            Sleep (0x10)
            Store (Zero, Local0)
            While (L23E)
            {
                If (LGreater (Local0, 0x04))
                {
                    Break
                }

                Sleep (0x10)
                Increment (Local0)
            }

            Store (One, LEDM)
            If (LNotEqual (DerefOf (Index (RSTG, Zero)), Zero))
            {
                If (LEqual (DerefOf (Index (RSTG, Zero)), One))
                {
                    \_SB.SGOV (DerefOf (Index (RSTG, 0x02)), XOr (DerefOf (Index (RSTG, 0x03)), One))
                }

                If (LEqual (DerefOf (Index (RSTG, Zero)), 0x02))
                {
                    \_SB.PCI0.GEXP.SGEP (DerefOf (Index (RSTG, One)), DerefOf (Index (RSTG, 0x02)), XOr (DerefOf (Index (RSTG, 0x03)), One))
                }
            }

            If (LNotEqual (DerefOf (Index (SCLK, Zero)), Zero))
            {
                PCRO (0xDC, 0x100C, DerefOf (Index (SCLK, One)))
                Sleep (0x10)
            }

            If (LNotEqual (DerefOf (Index (PWRG, Zero)), Zero))
            {
                If (LEqual (DerefOf (Index (PWRG, Zero)), One))
                {
                    \_SB.SGOV (DerefOf (Index (PWRG, 0x02)), XOr (DerefOf (Index (PWRG, 0x03)), One))
                }

                If (LEqual (DerefOf (Index (PWRG, Zero)), 0x02))
                {
                    \_SB.PCI0.GEXP.SGEP (DerefOf (Index (PWRG, One)), DerefOf (Index (PWRG, 0x02)), XOr (DerefOf (Index (PWRG, 0x03)), One))
                }
            }

            Store (One, LDIS)
            Store (Zero, LDIS)
            If (WKEN)
            {
                If (LNotEqual (DerefOf (Index (WAKG, Zero)), Zero))
                {
                    If (LEqual (DerefOf (Index (WAKG, Zero)), One))
                    {
                        \_SB.SGOV (DerefOf (Index (WAKG, 0x02)), DerefOf (Index (WAKG, 0x03)))
                        \_SB.SHPO (DerefOf (Index (WAKG, 0x02)), Zero)
                    }

                    If (LEqual (DerefOf (Index (WAKG, Zero)), 0x02))
                    {
                        \_SB.PCI0.GEXP.SGEP (DerefOf (Index (WAKG, One)), DerefOf (Index (WAKG, 0x02)), DerefOf (Index (WAKG, 0x03)))
                    }
                }
            }
        }

        Name (_PR0, Package (0x01)  // _PR0: Power Resources for D0
        {
            PXP
        })
    }

    Scope (\_SB.PCI0.SAT0)
    {
        Method (_PS0, 0, Serialized)  // _PS0: Power State 0
        {
        }

        Method (_PS3, 0, Serialized)  // _PS3: Power State 3
        {
        }

        OperationRegion (SMIO, PCI_Config, 0x24, 0x04)
        Field (SMIO, AnyAcc, NoLock, Preserve)
        {
            MBR6,   32
        }

        OperationRegion (MAPR, PCI_Config, 0x90, 0x02)
        Field (MAPR, AnyAcc, NoLock, Preserve)
        {
                ,   6, 
            SMSR,   2
        }

        OperationRegion (PCIR, PCI_Config, Zero, 0x10)
        Field (PCIR, DWordAcc, NoLock, Preserve)
        {
            SVID,   16, 
            SDID,   16, 
            Offset (0x0A), 
            SUBC,   8
        }

        Scope (PRT0)
        {
            Name (PORT, Zero)
            Name (PBAR, 0x0118)
            Name (PWRG, Package (0x04)
            {
                Zero, 
                Zero, 
                Zero, 
                One
            })
            If (And (RCG1, One))
            {
                Method (_PR0, 0, NotSerialized)  // _PR0: Power Resources for D0
                {
                    If (LAnd (LGreaterEqual (\OSYS, 0x07DF), LEqual (\EMOD, One)))
                    {
                        If (CondRefOf (\_SB.MODS))
                        {
                            Return (Package (0x01)
                            {
                                \_SB.MODS
                            })
                        }
                    }
                    ElseIf (CondRefOf (SPPR))
                    {
                        Return (Package (0x01)
                        {
                            SPPR
                        })
                    }

                    Return (Package (0x00) {})
                }

                Method (_PR3, 0, NotSerialized)  // _PR3: Power Resources for D3hot
                {
                    If (LAnd (LGreaterEqual (\OSYS, 0x07DF), LEqual (\EMOD, One)))
                    {
                        If (CondRefOf (\_SB.MODS))
                        {
                            Return (Package (0x01)
                            {
                                \_SB.MODS
                            })
                        }
                    }
                    ElseIf (CondRefOf (SPPR))
                    {
                        Return (Package (0x01)
                        {
                            SPPR
                        })
                    }

                    Return (Package (0x00) {})
                }

                PowerResource (SPPR, 0x00, 0x0000)
                {
                    Method (_STA, 0, NotSerialized)  // _STA: Status
                    {
                        If (LEqual (\EMOD, One))
                        {
                            Return (One)
                        }
                        Else
                        {
                            Return (SPSA ())
                        }
                    }

                    Method (_ON, 0, NotSerialized)  // _ON_: Power On
                    {
                        If (LNotEqual (IR3E (), Zero))
                        {
                            If (LEqual (\EMOD, One)) {}
                            ElseIf (LEqual (RAID (), Zero))
                            {
                                SPON ()
                                Sleep (0x10)
                            }
                        }
                    }

                    Method (_OFF, 0, NotSerialized)  // _OFF: Power Off
                    {
                        If (LNotEqual (IR3E (), Zero))
                        {
                            If (LEqual (\EMOD, One)) {}
                            ElseIf (LEqual (RAID (), Zero))
                            {
                                SPOF ()
                            }
                        }
                    }
                }

                Name (OFTM, Zero)
                Method (SPSA, 0, NotSerialized)
                {
                    Return (PSTA (PWRG))
                }

                Method (SPON, 0, NotSerialized)
                {
                    PON (PWRG)
                }

                Method (SPOF, 0, NotSerialized)
                {
                    Add (\_SB.PCI0.SAT0.MBR6, PBAR, Local0)
                    If (LEqual (S0ID, One))
                    {
                        OperationRegion (PSTS, SystemMemory, Local0, 0x18)
                        Field (PSTS, DWordAcc, NoLock, Preserve)
                        {
                            CMST,   1, 
                            CSUD,   1, 
                                ,   2, 
                            CFRE,   1, 
                            Offset (0x10), 
                            SDET,   4, 
                            Offset (0x14), 
                            CDET,   4
                        }

                        If (LAnd (LEqual (\_SB.PCI0.SAT0.SUBC, 0x06), LOr (LEqual (SDET, One), LEqual (SDET, 0x03))))
                        {
                            Store (Zero, CMST)
                            Store (Zero, CFRE)
                            Store (Zero, CSUD)
                            Store (0x04, CDET)
                            Sleep (0x10)
                            While (LNotEqual (SDET, 0x04))
                            {
                                Sleep (0x10)
                            }
                        }
                    }

                    POFF (PWRG)
                    Store (Timer, ^OFTM)
                }
            }
        }

        Scope (PRT1)
        {
            Name (PORT, One)
            Name (PBAR, 0x0198)
            Name (PWRG, Package (0x04)
            {
                Zero, 
                Zero, 
                Zero, 
                One
            })
            If (And (RCG1, 0x02))
            {
                Method (_PR0, 0, NotSerialized)  // _PR0: Power Resources for D0
                {
                    If (LAnd (LGreaterEqual (\OSYS, 0x07DF), LEqual (\EMOD, One)))
                    {
                        If (CondRefOf (\_SB.MODS))
                        {
                            Return (Package (0x01)
                            {
                                \_SB.MODS
                            })
                        }
                    }
                    ElseIf (CondRefOf (SPPR))
                    {
                        Return (Package (0x01)
                        {
                            SPPR
                        })
                    }

                    Return (Package (0x00) {})
                }

                Method (_PR3, 0, NotSerialized)  // _PR3: Power Resources for D3hot
                {
                    If (LAnd (LGreaterEqual (\OSYS, 0x07DF), LEqual (\EMOD, One)))
                    {
                        If (CondRefOf (\_SB.MODS))
                        {
                            Return (Package (0x01)
                            {
                                \_SB.MODS
                            })
                        }
                    }
                    ElseIf (CondRefOf (SPPR))
                    {
                        Return (Package (0x01)
                        {
                            SPPR
                        })
                    }

                    Return (Package (0x00) {})
                }

                PowerResource (SPPR, 0x00, 0x0000)
                {
                    Method (_STA, 0, NotSerialized)  // _STA: Status
                    {
                        If (LEqual (\EMOD, One))
                        {
                            Return (One)
                        }
                        Else
                        {
                            Return (SPSA ())
                        }
                    }

                    Method (_ON, 0, NotSerialized)  // _ON_: Power On
                    {
                        If (LNotEqual (IR3E (), Zero))
                        {
                            If (LEqual (\EMOD, One)) {}
                            ElseIf (LEqual (RAID (), Zero))
                            {
                                SPON ()
                                Sleep (0x10)
                            }
                        }
                    }

                    Method (_OFF, 0, NotSerialized)  // _OFF: Power Off
                    {
                        If (LNotEqual (IR3E (), Zero))
                        {
                            If (LEqual (\EMOD, One)) {}
                            ElseIf (LEqual (RAID (), Zero))
                            {
                                SPOF ()
                            }
                        }
                    }
                }

                Name (OFTM, Zero)
                Method (SPSA, 0, NotSerialized)
                {
                    Return (PSTA (PWRG))
                }

                Method (SPON, 0, NotSerialized)
                {
                    PON (PWRG)
                }

                Method (SPOF, 0, NotSerialized)
                {
                    Add (\_SB.PCI0.SAT0.MBR6, PBAR, Local0)
                    If (LEqual (S0ID, One))
                    {
                        OperationRegion (PSTS, SystemMemory, Local0, 0x18)
                        Field (PSTS, DWordAcc, NoLock, Preserve)
                        {
                            CMST,   1, 
                            CSUD,   1, 
                                ,   2, 
                            CFRE,   1, 
                            Offset (0x10), 
                            SDET,   4, 
                            Offset (0x14), 
                            CDET,   4
                        }

                        If (LAnd (LEqual (\_SB.PCI0.SAT0.SUBC, 0x06), LOr (LEqual (SDET, One), LEqual (SDET, 0x03))))
                        {
                            Store (Zero, CMST)
                            Store (Zero, CFRE)
                            Store (Zero, CSUD)
                            Store (0x04, CDET)
                            Sleep (0x10)
                            While (LNotEqual (SDET, 0x04))
                            {
                                Sleep (0x10)
                            }
                        }
                    }

                    POFF (PWRG)
                    Store (Timer, ^OFTM)
                }
            }
        }

        Scope (PRT2)
        {
            Name (PORT, 0x02)
            Name (PBAR, 0x0218)
            Name (PWRG, Package (0x04)
            {
                Zero, 
                Zero, 
                Zero, 
                One
            })
            If (And (RCG1, 0x04))
            {
                Method (_PR0, 0, NotSerialized)  // _PR0: Power Resources for D0
                {
                    If (LAnd (LGreaterEqual (\OSYS, 0x07DF), LEqual (\EMOD, One)))
                    {
                        If (CondRefOf (\_SB.MODS))
                        {
                            Return (Package (0x01)
                            {
                                \_SB.MODS
                            })
                        }
                    }
                    ElseIf (CondRefOf (SPPR))
                    {
                        Return (Package (0x01)
                        {
                            SPPR
                        })
                    }

                    Return (Package (0x00) {})
                }

                Method (_PR3, 0, NotSerialized)  // _PR3: Power Resources for D3hot
                {
                    If (LAnd (LGreaterEqual (\OSYS, 0x07DF), LEqual (\EMOD, One)))
                    {
                        If (CondRefOf (\_SB.MODS))
                        {
                            Return (Package (0x01)
                            {
                                \_SB.MODS
                            })
                        }
                    }
                    ElseIf (CondRefOf (SPPR))
                    {
                        Return (Package (0x01)
                        {
                            SPPR
                        })
                    }

                    Return (Package (0x00) {})
                }

                PowerResource (SPPR, 0x00, 0x0000)
                {
                    Method (_STA, 0, NotSerialized)  // _STA: Status
                    {
                        If (LEqual (\EMOD, One))
                        {
                            Return (One)
                        }
                        Else
                        {
                            Return (SPSA ())
                        }
                    }

                    Method (_ON, 0, NotSerialized)  // _ON_: Power On
                    {
                        If (LNotEqual (IR3E (), Zero))
                        {
                            If (LEqual (\EMOD, One)) {}
                            ElseIf (LEqual (RAID (), Zero))
                            {
                                SPON ()
                                Sleep (0x10)
                            }
                        }
                    }

                    Method (_OFF, 0, NotSerialized)  // _OFF: Power Off
                    {
                        If (LNotEqual (IR3E (), Zero))
                        {
                            If (LEqual (\EMOD, One)) {}
                            ElseIf (LEqual (RAID (), Zero))
                            {
                                SPOF ()
                            }
                        }
                    }
                }

                Name (OFTM, Zero)
                Method (SPSA, 0, NotSerialized)
                {
                    Return (PSTA (PWRG))
                }

                Method (SPON, 0, NotSerialized)
                {
                    PON (PWRG)
                }

                Method (SPOF, 0, NotSerialized)
                {
                    Add (\_SB.PCI0.SAT0.MBR6, PBAR, Local0)
                    If (LEqual (S0ID, One))
                    {
                        OperationRegion (PSTS, SystemMemory, Local0, 0x18)
                        Field (PSTS, DWordAcc, NoLock, Preserve)
                        {
                            CMST,   1, 
                            CSUD,   1, 
                                ,   2, 
                            CFRE,   1, 
                            Offset (0x10), 
                            SDET,   4, 
                            Offset (0x14), 
                            CDET,   4
                        }

                        If (LAnd (LEqual (\_SB.PCI0.SAT0.SUBC, 0x06), LOr (LEqual (SDET, One), LEqual (SDET, 0x03))))
                        {
                            Store (Zero, CMST)
                            Store (Zero, CFRE)
                            Store (Zero, CSUD)
                            Store (0x04, CDET)
                            Sleep (0x10)
                            While (LNotEqual (SDET, 0x04))
                            {
                                Sleep (0x10)
                            }
                        }
                    }

                    POFF (PWRG)
                    Store (Timer, ^OFTM)
                }
            }
        }
    }

    Scope (\_SB.PCI0.SAT0)
    {
        Name (VL0M, Zero)
        Name (VL1M, Zero)
        Name (VL2M, Zero)
        Name (VR3A, One)
        Scope (PRT0)
        {
            Name (VLPM, One)
            Name (RCGM, One)
            Method (RAID, 0, NotSerialized)
            {
                If (LNot (Or (Or (And (VL0M, VLPM), And (VL1M, VLPM)), And (VL2M, VLPM))))
                {
                    Return (Zero)
                }

                Return (One)
            }

            Method (IR3E, 0, NotSerialized)
            {
                If (LAnd (And (RCG1, RCGM), VR3A))
                {
                    Return (One)
                }

                Return (Zero)
            }
        }

        Scope (PRT1)
        {
            Name (VLPM, 0x02)
            Name (RCGM, 0x02)
            Method (RAID, 0, NotSerialized)
            {
                If (LNot (Or (Or (And (VL0M, VLPM), And (VL1M, VLPM)), And (VL2M, VLPM))))
                {
                    Return (Zero)
                }

                Return (One)
            }

            Method (IR3E, 0, NotSerialized)
            {
                If (LAnd (And (RCG1, RCGM), VR3A))
                {
                    Return (One)
                }

                Return (Zero)
            }
        }

        Scope (PRT2)
        {
            Name (VLPM, 0x04)
            Name (RCGM, 0x04)
            Method (RAID, 0, NotSerialized)
            {
                If (LNot (Or (Or (And (VL0M, VLPM), And (VL1M, VLPM)), And (VL2M, VLPM))))
                {
                    Return (Zero)
                }

                Return (One)
            }

            Method (IR3E, 0, NotSerialized)
            {
                If (LAnd (And (RCG1, RCGM), VR3A))
                {
                    Return (One)
                }

                Return (Zero)
            }
        }

        Scope (PRT3)
        {
            Name (VLPM, 0x08)
            Name (RCGM, 0x08)
            Method (RAID, 0, NotSerialized)
            {
                If (LNot (Or (Or (And (VL0M, VLPM), And (VL1M, VLPM)), And (VL2M, VLPM))))
                {
                    Return (Zero)
                }

                Return (One)
            }

            Method (IR3E, 0, NotSerialized)
            {
                If (LAnd (And (RCG1, RCGM), VR3A))
                {
                    Return (One)
                }

                Return (Zero)
            }
        }

        Scope (PRT4)
        {
            Name (VLPM, 0x10)
            Name (RCGM, 0x10)
            Method (RAID, 0, NotSerialized)
            {
                If (LNot (Or (Or (And (VL0M, VLPM), And (VL1M, VLPM)), And (VL2M, VLPM))))
                {
                    Return (Zero)
                }

                Return (One)
            }

            Method (IR3E, 0, NotSerialized)
            {
                If (LAnd (And (RCG1, RCGM), VR3A))
                {
                    Return (One)
                }

                Return (Zero)
            }
        }

        Scope (PRT5)
        {
            Name (VLPM, 0x20)
            Name (RCGM, 0x20)
            Method (RAID, 0, NotSerialized)
            {
                If (LNot (Or (Or (And (VL0M, VLPM), And (VL1M, VLPM)), And (VL2M, VLPM))))
                {
                    Return (Zero)
                }

                Return (One)
            }

            Method (IR3E, 0, NotSerialized)
            {
                If (LAnd (And (RCG1, RCGM), VR3A))
                {
                    Return (One)
                }

                Return (Zero)
            }
        }

        Scope (NVM1)
        {
            Name (VLPM, 0x0100)
            Name (RCGM, 0x40)
            Method (RAID, 0, NotSerialized)
            {
                If (LNot (Or (Or (And (VL0M, VLPM), And (VL1M, VLPM)), And (VL2M, VLPM))))
                {
                    Return (Zero)
                }

                Return (One)
            }

            Method (IR3E, 0, NotSerialized)
            {
                If (LAnd (And (RCG1, RCGM), VR3A))
                {
                    Return (One)
                }

                Return (Zero)
            }
        }

        Scope (NVM2)
        {
            Name (VLPM, 0x0200)
            Name (RCGM, 0x80)
            Method (RAID, 0, NotSerialized)
            {
                If (LNot (Or (Or (And (VL0M, VLPM), And (VL1M, VLPM)), And (VL2M, VLPM))))
                {
                    Return (Zero)
                }

                Return (One)
            }

            Method (IR3E, 0, NotSerialized)
            {
                If (LAnd (And (RCG1, RCGM), VR3A))
                {
                    Return (One)
                }

                Return (Zero)
            }
        }

        Scope (NVM3)
        {
            Name (VLPM, 0x0400)
            Name (RCGM, 0x0100)
            Method (RAID, 0, NotSerialized)
            {
                If (LNot (Or (Or (And (VL0M, VLPM), And (VL1M, VLPM)), And (VL2M, VLPM))))
                {
                    Return (Zero)
                }

                Return (One)
            }

            Method (IR3E, 0, NotSerialized)
            {
                If (LAnd (And (RCG1, RCGM), VR3A))
                {
                    Return (One)
                }

                Return (Zero)
            }
        }

        Method (RSTD, 5, Serialized)
        {
            Name (_T_0, Zero)  // _T_x: Emitted by ASL Compiler
            If (LEqual (Arg0, ToUUID ("e03e3431-e510-4fa2-abc0-2d7e901245fe")))
            {
                While (One)
                {
                    Store (ToInteger (Arg2), _T_0)
                    If (LEqual (_T_0, Zero))
                    {
                        Name (RBUF, Buffer (One)
                        {
                             0x00                                           
                        })
                        CreateByteField (RBUF, Zero, SFUN)
                        Store (0x03, SFUN)
                        Return (RBUF)
                    }
                    ElseIf (LEqual (_T_0, One))
                    {
                        Store (DerefOf (Index (Arg3, Zero)), Arg4)
                        Store (DerefOf (Index (Arg3, Zero)), Local0)
                        Return (Package (0x01)
                        {
                            Zero
                        })
                    }
                    ElseIf (LEqual (_T_0, 0x02))
                    {
                        Store (DerefOf (Index (Arg3, Zero)), Local0)
                        \_SB.PCI0.SAT0.CPON (Local0)
                        Return (Package (0x01)
                        {
                            Zero
                        })
                    }
                    ElseIf (LEqual (_T_0, 0x03))
                    {
                        Store (DerefOf (Index (Arg3, Zero)), Local0)
                        \_SB.PCI0.SAT0.CPOF (Local0)
                        Return (Package (0x01)
                        {
                            Zero
                        })
                    }
                    ElseIf (LEqual (_T_0, 0x04))
                    {
                        Name (GETM, Buffer (One)
                        {
                             0x00                                           
                        })
                        CreateByteField (GETM, Zero, GMSK)
                        Store (Arg4, GMSK)
                        Return (GETM)
                    }
                    ElseIf (LEqual (_T_0, 0x05))
                    {
                        Store (DerefOf (Index (Arg3, Zero)), VR3A)
                        Return (Zero)
                    }
                    Else
                    {
                        Return (Package (0x01)
                        {
                            0x02
                        })
                    }

                    Break
                }
            }
            Else
            {
                Return (Buffer (One)
                {
                     0x00                                           
                })
            }
        }

        Device (VOL0)
        {
            Name (_ADR, 0x0080FFFF)  // _ADR: Address
            Name (_PR0, Package (0x01)  // _PR0: Power Resources for D0
            {
                V0PR
            })
            Name (_PR3, Package (0x01)  // _PR3: Power Resources for D3hot
            {
                V0PR
            })
            Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
            {
                Return (\_SB.PCI0.SAT0.RSTD (Arg0, Arg1, Arg2, Arg3, RefOf (\_SB.PCI0.SAT0.VL0M)))
            }

            PowerResource (V0PR, 0x00, 0x0000)
            {
                Name (_STA, One)  // _STA: Status
                Method (_ON, 0, NotSerialized)  // _ON_: Power On
                {
                    Store (One, _STA)
                    \_SB.PCI0.SAT0.CPON (VL0M)
                }

                Method (_OFF, 0, NotSerialized)  // _OFF: Power Off
                {
                    Store (Zero, _STA)
                    \_SB.PCI0.SAT0.CPOF (VL0M)
                }
            }
        }

        Device (VOL1)
        {
            Name (_ADR, 0x0081FFFF)  // _ADR: Address
            Name (_PR0, Package (0x01)  // _PR0: Power Resources for D0
            {
                V1PR
            })
            Name (_PR3, Package (0x01)  // _PR3: Power Resources for D3hot
            {
                V1PR
            })
            Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
            {
                Return (\_SB.PCI0.SAT0.RSTD (Arg0, Arg1, Arg2, Arg3, RefOf (\_SB.PCI0.SAT0.VL1M)))
            }

            PowerResource (V1PR, 0x00, 0x0000)
            {
                Name (_STA, One)  // _STA: Status
                Method (_ON, 0, NotSerialized)  // _ON_: Power On
                {
                    Store (One, _STA)
                    \_SB.PCI0.SAT0.CPON (VL1M)
                }

                Method (_OFF, 0, NotSerialized)  // _OFF: Power Off
                {
                    Store (Zero, _STA)
                    \_SB.PCI0.SAT0.CPOF (VL1M)
                }
            }
        }

        Device (VOL2)
        {
            Name (_ADR, 0x0082FFFF)  // _ADR: Address
            Name (_PR0, Package (0x01)  // _PR0: Power Resources for D0
            {
                V2PR
            })
            Name (_PR3, Package (0x01)  // _PR3: Power Resources for D3hot
            {
                V2PR
            })
            Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
            {
                Return (\_SB.PCI0.SAT0.RSTD (Arg0, Arg1, Arg2, Arg3, RefOf (\_SB.PCI0.SAT0.VL2M)))
            }

            PowerResource (V2PR, 0x00, 0x0000)
            {
                Name (_STA, One)  // _STA: Status
                Method (_ON, 0, NotSerialized)  // _ON_: Power On
                {
                    Store (One, _STA)
                    \_SB.PCI0.SAT0.CPON (VL2M)
                }

                Method (_OFF, 0, NotSerialized)  // _OFF: Power Off
                {
                    Store (Zero, _STA)
                    \_SB.PCI0.SAT0.CPOF (VL2M)
                }
            }
        }

        Method (CPON, 1, Serialized)
        {
            If (LAnd (And (RCG1, One), And (Arg0, One)))
            {
                \_SB.PCI0.SAT0.PRT0.SPON ()
            }

            If (LAnd (And (RCG1, 0x02), And (Arg0, 0x02)))
            {
                \_SB.PCI0.SAT0.PRT1.SPON ()
            }

            If (LAnd (And (RCG1, 0x04), And (Arg0, 0x04)))
            {
                \_SB.PCI0.SAT0.PRT2.SPON ()
            }

            If (LAnd (And (RCG1, 0x80), And (Arg0, 0x0200)))
            {
                \_SB.PCI0.SAT0.NVM2.RPON ()
            }
        }

        Method (CPOF, 1, Serialized)
        {
            If (LAnd (And (RCG1, One), And (Arg0, One)))
            {
                \_SB.PCI0.SAT0.PRT0.SPOF ()
            }

            If (LAnd (And (RCG1, 0x02), And (Arg0, 0x02)))
            {
                \_SB.PCI0.SAT0.PRT1.SPOF ()
            }

            If (LAnd (And (RCG1, 0x04), And (Arg0, 0x04)))
            {
                \_SB.PCI0.SAT0.PRT2.SPOF ()
            }

            If (LAnd (And (RCG1, 0x80), And (Arg0, 0x0200)))
            {
                \_SB.PCI0.SAT0.NVM2.RPOF ()
            }
        }
    }

    Scope (\_SB.PCI0.SAT0)
    {
        Name (DRV, Zero)
        Name (PWR, Zero)
        Method (SDSM, 4, Serialized)
        {
            Name (_T_2, Zero)  // _T_x: Emitted by ASL Compiler
            Name (_T_1, Zero)  // _T_x: Emitted by ASL Compiler
            Name (_T_0, Zero)  // _T_x: Emitted by ASL Compiler
            If (LEqual (Arg0, ToUUID ("e4db149b-fcfe-425b-a6d8-92357d78fc7f") /* SATA Controller */))
            {
                While (One)
                {
                    Store (ToInteger (Arg2), _T_0)
                    If (LEqual (_T_0, Zero))
                    {
                        Return (0x0F)
                    }
                    ElseIf (LEqual (_T_0, One))
                    {
                        Return (Package (0x00) {})
                    }
                    ElseIf (LEqual (_T_0, 0x02))
                    {
                        Store (ToInteger (DerefOf (Index (Arg3, Zero))), DRV)
                        Store (ToInteger (DerefOf (Index (Arg3, One))), PWR)
                        While (One)
                        {
                            Store (ToInteger (DRV), _T_1)
                            If (LEqual (_T_1, Ones))
                            {
                                If (PWR)
                                {
                                    \_SB.PCI0.SAT0.PRT0.SPPR._ON ()
                                    \_SB.PCI0.SAT0.PRT1.SPPR._ON ()
                                    \_SB.PCI0.SAT0.PRT2.SPPR._ON ()
                                }
                            }

                            Break
                        }

                        Return (Zero)
                    }
                    ElseIf (LEqual (_T_0, 0x03))
                    {
                        Store (ToInteger (DerefOf (Index (Arg3, Zero))), DRV)
                        While (One)
                        {
                            Store (ToInteger (DRV), _T_2)
                            If (LEqual (_T_2, 0xFFFF))
                            {
                                If (LEqual (\_SB.PCI0.SAT0.PRT0.SPPR._STA (), Zero))
                                {
                                    Store (Zero, Local0)
                                }
                                Else
                                {
                                    Store (One, Local0)
                                }

                                Return (Local0)
                            }
                            ElseIf (LEqual (_T_2, 0x0001FFFF))
                            {
                                If (LEqual (\_SB.PCI0.SAT0.PRT1.SPPR._STA (), Zero))
                                {
                                    Store (Zero, Local0)
                                }
                                Else
                                {
                                    Store (One, Local0)
                                }

                                Return (Local0)
                            }
                            ElseIf (LEqual (_T_2, 0x0002FFFF))
                            {
                                If (LEqual (\_SB.PCI0.SAT0.PRT2.SPPR._STA (), Zero))
                                {
                                    Store (Zero, Local0)
                                }
                                Else
                                {
                                    Store (One, Local0)
                                }

                                Return (Local0)
                            }
                            Else
                            {
                                Return (Ones)
                            }

                            Break
                        }
                    }
                    Else
                    {
                        Return (Zero)
                    }

                    Break
                }
            }
            Else
            {
                Return (Buffer (One)
                {
                     0x00                                           
                })
            }
        }
    }

    Scope (\_SB.PCI0.XHC)
    {
        Name (UPWR, Zero)
        Name (USPP, Zero)
        Method (DUAM, 0, Serialized)
        {
            OperationRegion (XHCM, SystemMemory, And (MEMB, 0xFFFF0000), 0x0600)
            Field (XHCM, DWordAcc, NoLock, Preserve)
            {
                Offset (0x02), 
                XHCV,   16, 
                Offset (0x480), 
                HP01,   1, 
                Offset (0x4C0), 
                HP05,   1, 
                Offset (0x540), 
                SP01,   1, 
                Offset (0x570), 
                SP04,   1
            }

            If (LNotEqual (\UAMS, Zero))
            {
                Store (Zero, \_SB.PCI0.XHC.UPWR)
                If (LEqual (XHCV, 0xFFFF))
                {
                    If (And (\_SB.PCI0.XHC.USPP, 0x02))
                    {
                        Or (\_SB.PCI0.XHC.UPWR, 0x02, \_SB.PCI0.XHC.UPWR)
                    }

                    If (And (\_SB.PCI0.XHC.USPP, 0x04))
                    {
                        Or (\_SB.PCI0.XHC.UPWR, 0x04, \_SB.PCI0.XHC.UPWR)
                    }
                }
                Else
                {
                    If (LAnd (LEqual (HP05, Zero), LEqual (SP04, Zero)))
                    {
                        Or (\_SB.PCI0.XHC.UPWR, 0x02, \_SB.PCI0.XHC.UPWR)
                    }

                    If (LAnd (LEqual (HP01, Zero), LEqual (SP01, Zero)))
                    {
                        Or (\_SB.PCI0.XHC.UPWR, 0x04, \_SB.PCI0.XHC.UPWR)
                    }
                }
            }
            Else
            {
                If (And (\_SB.PCI0.XHC.UPWR, 0x02)) {}
                If (And (\_SB.PCI0.XHC.UPWR, 0x04)) {}
            }
        }
    }

    Scope (\_SB.PCI0.XHC.RHUB)
    {
        Method (PS0X, 0, Serialized)
        {
            Store (Zero, \_SB.PCI0.XHC.USPP)
        }

        Method (PS2X, 0, Serialized)
        {
            OperationRegion (XHCM, SystemMemory, And (MEMB, 0xFFFFFFFFFFFF0000), 0x0600)
            Field (XHCM, DWordAcc, NoLock, Preserve)
            {
                Offset (0x02), 
                XHCV,   16, 
                Offset (0x480), 
                HP01,   1, 
                Offset (0x4C0), 
                HP05,   1, 
                Offset (0x540), 
                SP01,   1, 
                Offset (0x570), 
                SP04,   1
            }

            If (LEqual (XHCV, 0xFFFF))
            {
                Return (Zero)
            }

            If (LAnd (LEqual (HP05, Zero), LEqual (SP04, Zero)))
            {
                Or (\_SB.PCI0.XHC.USPP, 0x02, \_SB.PCI0.XHC.USPP)
            }

            If (LAnd (LEqual (HP01, Zero), LEqual (SP01, Zero)))
            {
                Or (\_SB.PCI0.XHC.USPP, 0x04, \_SB.PCI0.XHC.USPP)
            }
        }

        Method (PS3X, 0, Serialized)
        {
        }
    }

    If (LNotEqual (And (XHPR, 0x0F), Zero))
    {
        Scope (\_SB.PCI0.XHC.RHUB)
        {
            PowerResource (PX01, 0x00, 0x0000)
            {
                Method (_STA, 0, NotSerialized)  // _STA: Status
                {
                    Return (One)
                }

                Method (_ON, 0, NotSerialized)  // _ON_: Power On
                {
                }

                Method (_OFF, 0, NotSerialized)  // _OFF: Power Off
                {
                }
            }
        }
    }

    If (LNotEqual (And (XHPR, 0xF0), Zero))
    {
        Scope (\_SB.PCI0.XHC.RHUB)
        {
            PowerResource (PX02, 0x00, 0x0000)
            {
                Method (_STA, 0, NotSerialized)  // _STA: Status
                {
                    Return (One)
                }

                Method (_ON, 0, NotSerialized)  // _ON_: Power On
                {
                }

                Method (_OFF, 0, NotSerialized)  // _OFF: Power Off
                {
                }
            }
        }
    }

    Scope (\_SB.PCI0.XHC.RHUB)
    {
        Name (CPWR, Zero)
        Method (CMSA, 0, NotSerialized)
        {
            If (LEqual (\_SB.GGOV (0x02010002), One))
            {
                Return (One)
            }

            Return (Zero)
        }

        Method (CMON, 0, NotSerialized)
        {
            If (LNotEqual (CPWR, One))
            {
                If (LEqual (CAMT, One))
                {
                    If (CondRefOf (\_SB.ICAM.IPWR))
                    {
                        If (LEqual (\_SB.ICAM.IPWR, Zero))
                        {
                            \_SB.WRGP (IVDG, One)
                            \_SB.SGOV (0x02010002, One)
                            Sleep (0x64)
                            Store (One, CPWR)
                        }
                    }
                }
                ElseIf (LEqual (CAMT, 0x02))
                {
                    \_SB.SGOV (0x02010002, One)
                    Sleep (DDSO)
                    Store (One, CPWR)
                }
            }
        }

        Method (COFF, 0, NotSerialized)
        {
            If (LNotEqual (CPWR, Zero))
            {
                If (LEqual (CAMT, One))
                {
                    If (CondRefOf (\_SB.ICAM.IDFU))
                    {
                        If (LEqual (\_SB.ICAM.IDFU, Zero))
                        {
                            \_SB.SGOV (0x02010002, Zero)
                            Store (Zero, CPWR)
                        }
                    }
                }
                ElseIf (LEqual (CAMT, 0x02))
                {
                    \_SB.SGOV (0x02010002, Zero)
                    Sleep (DDSF)
                    Store (Zero, CPWR)
                }
            }
        }
    }

    If (LEqual (And (RCG0, 0x02), 0x02))
    {
        Scope (\_SB.PCI0.XHC.RHUB)
        {
            PowerResource (PCAM, 0x00, 0x0000)
            {
                Method (_STA, 0, NotSerialized)  // _STA: Status
                {
                    If (LEqual (\EMOD, One))
                    {
                        Return (One)
                    }
                    Else
                    {
                        Return (CMSA ())
                    }
                }

                Method (_ON, 0, Serialized)  // _ON_: Power On
                {
                    If (LEqual (\EMOD, One)) {}
                    Else
                    {
                        CMON ()
                    }
                }

                Method (_OFF, 0, Serialized)  // _OFF: Power Off
                {
                    If (LEqual (\EMOD, One)) {}
                    Else
                    {
                        COFF ()
                    }
                }
            }
        }
    }

    If (LEqual (And (RCG0, 0x02), 0x02))
    {
        Scope (\_SB.PCI0.XHC.RHUB.SS03)
        {
            Name (_S0W, 0x04)  // _S0W: S0 Device Wake State
            Method (_PR0, 0, NotSerialized)  // _PR0: Power Resources for D0
            {
                If (LAnd (LGreaterEqual (\OSYS, 0x07DF), LEqual (\EMOD, One)))
                {
                    If (CondRefOf (\_SB.MODS))
                    {
                        Return (Package (0x01)
                        {
                            \_SB.MODS
                        })
                    }
                }
                Else
                {
                    Return (Package (0x01)
                    {
                        \_SB.PCI0.XHC.RHUB.PCAM
                    })
                }

                Return (Package (0x00) {})
            }

            Method (_PR2, 0, NotSerialized)  // _PR2: Power Resources for D2
            {
                If (LAnd (LGreaterEqual (\OSYS, 0x07DF), LEqual (\EMOD, One)))
                {
                    If (CondRefOf (\_SB.MODS))
                    {
                        Return (Package (0x01)
                        {
                            \_SB.MODS
                        })
                    }
                }
                Else
                {
                    Return (Package (0x01)
                    {
                        \_SB.PCI0.XHC.RHUB.PCAM
                    })
                }

                Return (Package (0x00) {})
            }

            Method (_PR3, 0, NotSerialized)  // _PR3: Power Resources for D3hot
            {
                If (LAnd (LGreaterEqual (\OSYS, 0x07DF), LEqual (\EMOD, One)))
                {
                    If (CondRefOf (\_SB.MODS))
                    {
                        Return (Package (0x01)
                        {
                            \_SB.MODS
                        })
                    }
                }
                Else
                {
                    Return (Package (0x01)
                    {
                        \_SB.PCI0.XHC.RHUB.PCAM
                    })
                }

                Return (Package (0x00) {})
            }
        }
    }

    If (LEqual (And (RCG0, 0x80), 0x80))
    {
        Scope (\_SB.PCI0.XHC.RHUB)
        {
            PowerResource (PX03, 0x00, 0x0000)
            {
                Name (WOFF, Zero)
                Name (TIM1, Zero)
                Method (_STA, 0, NotSerialized)  // _STA: Status
                {
                    If (LEqual (\_SB.GGOV (0x0204000B), One))
                    {
                        Return (One)
                    }
                    Else
                    {
                        Return (Zero)
                    }
                }

                Method (_ON, 0, NotSerialized)  // _ON_: Power On
                {
                    If (LNotEqual (^WOFF, Zero))
                    {
                        Divide (Subtract (Timer, ^WOFF), 0x2710, , Local0)
                        If (LLess (Local0, 0x0258))
                        {
                            Sleep (Subtract (0x0258, Local0))
                        }

                        Store (Zero, ^WOFF)
                    }

                    Store (Timer, ^TIM1)
                    \_SB.SGOV (\WGUR, One)
                    Divide (Subtract (Timer, ^TIM1), 0x2710, , Local0)
                    If (LLess (Local0, 0x64))
                    {
                        Sleep (Subtract (0x64, Local0))
                    }

                    \_SB.SGOV (0x0204000B, One)
                }

                Method (_OFF, 0, NotSerialized)  // _OFF: Power Off
                {
                    Store (Timer, ^TIM1)
                    \_SB.SGOV (\WGUR, Zero)
                    Divide (Subtract (Timer, ^TIM1), 0x2710, , Local0)
                    If (LLess (Local0, 0x64))
                    {
                        Sleep (Subtract (0x64, Local0))
                    }

                    \_SB.SGOV (0x0204000B, Zero)
                    Store (Timer, ^WOFF)
                }
            }
        }

        Scope (\_SB.PCI0.XHC.RHUB.HS03)
        {
            Name (_S0W, 0x02)  // _S0W: S0 Device Wake State
            Name (_PR0, Package (0x01)  // _PR0: Power Resources for D0
            {
                \_SB.PCI0.XHC.RHUB.PX03
            })
            Name (_PR2, Package (0x01)  // _PR2: Power Resources for D2
            {
                \_SB.PCI0.XHC.RHUB.PX03
            })
            Name (_PR3, Package (0x01)  // _PR3: Power Resources for D3hot
            {
                \_SB.PCI0.XHC.RHUB.PX03
            })
            Device (MODM)
            {
                Name (_ADR, 0x03)  // _ADR: Address
                Name (_PR0, Package (0x01)  // _PR0: Power Resources for D0
                {
                    \_SB.PCI0.XHC.RHUB.PX03
                })
                Name (_PR2, Package (0x01)  // _PR2: Power Resources for D2
                {
                    \_SB.PCI0.XHC.RHUB.PX03
                })
                Name (_PR3, Package (0x01)  // _PR3: Power Resources for D3hot
                {
                    \_SB.PCI0.XHC.RHUB.PX03
                })
            }
        }

        Scope (\_GPE)
        {
        }
    }

    If (LEqual (And (XHPR, 0x0F), One))
    {
        Scope (\_SB.PCI0.XHC.RHUB.HS05)
        {
            Name (_PR0, Package (0x01)  // _PR0: Power Resources for D0
            {
                \_SB.PCI0.XHC.RHUB.PX01
            })
            Name (_PR2, Package (0x01)  // _PR2: Power Resources for D2
            {
                \_SB.PCI0.XHC.RHUB.PX01
            })
            Name (_PR3, Package (0x01)  // _PR3: Power Resources for D3hot
            {
                \_SB.PCI0.XHC.RHUB.PX01
            })
        }
    }

    If (LEqual (And (XHPR, 0xF0), 0x10))
    {
        Scope (\_SB.PCI0.XHC.RHUB.HS01)
        {
            Name (_PR0, Package (0x01)  // _PR0: Power Resources for D0
            {
                \_SB.PCI0.XHC.RHUB.PX02
            })
            Name (_PR2, Package (0x01)  // _PR2: Power Resources for D2
            {
                \_SB.PCI0.XHC.RHUB.PX02
            })
            Name (_PR3, Package (0x01)  // _PR3: Power Resources for D3hot
            {
                \_SB.PCI0.XHC.RHUB.PX02
            })
        }
    }

    If (LEqual (And (XHPR, 0x0F), 0x02))
    {
        Scope (\_SB.PCI0.XHC.RHUB.SS04)
        {
            Name (_PR0, Package (0x01)  // _PR0: Power Resources for D0
            {
                \_SB.PCI0.XHC.RHUB.PX01
            })
            Name (_PR2, Package (0x01)  // _PR2: Power Resources for D2
            {
                \_SB.PCI0.XHC.RHUB.PX01
            })
            Name (_PR3, Package (0x01)  // _PR3: Power Resources for D3hot
            {
                \_SB.PCI0.XHC.RHUB.PX01
            })
        }
    }

    If (LNotEqual (And (XHPR, 0x60), Zero))
    {
        Scope (\_SB.PCI0.XHC.RHUB.SS01)
        {
            Method (_PR0, 0, NotSerialized)  // _PR0: Power Resources for D0
            {
                If (LEqual (And (XHPR, 0x60), 0x20))
                {
                    Return (Package (0x01)
                    {
                        \_SB.PCI0.XHC.RHUB.PX02
                    })
                }
                ElseIf (LEqual (And (RCG0, 0x80), 0x80))
                {
                    Return (Package (0x01)
                    {
                        \_SB.PCI0.XHC.RHUB.PX03
                    })
                }

                Return (Package (0x00) {})
            }

            Method (_PR2, 0, NotSerialized)  // _PR2: Power Resources for D2
            {
                If (LEqual (And (XHPR, 0x60), 0x20))
                {
                    Return (Package (0x01)
                    {
                        \_SB.PCI0.XHC.RHUB.PX02
                    })
                }
                ElseIf (LEqual (And (RCG0, 0x80), 0x80))
                {
                    Return (Package (0x01)
                    {
                        \_SB.PCI0.XHC.RHUB.PX03
                    })
                }

                Return (Package (0x00) {})
            }

            Method (_PR3, 0, NotSerialized)  // _PR3: Power Resources for D3hot
            {
                If (LEqual (And (XHPR, 0x60), 0x20))
                {
                    Return (Package (0x01)
                    {
                        \_SB.PCI0.XHC.RHUB.PX02
                    })
                }
                ElseIf (LEqual (And (RCG0, 0x80), 0x80))
                {
                    Return (Package (0x01)
                    {
                        \_SB.PCI0.XHC.RHUB.PX03
                    })
                }

                Return (Package (0x00) {})
            }

            Method (_S0W, 0, NotSerialized)  // _S0W: S0 Device Wake State
            {
                If (LAnd (LEqual (And (RCG0, 0x80), 0x80), LEqual (And (XHPR, 0xF0), 0x40)))
                {
                    Return (0x02)
                }
                Else
                {
                    Return (Zero)
                }
            }
        }
    }

    If (LAnd (LEqual (And (XHPR, 0x40), 0x04), LEqual (And (RCG0, 0x80), 0x80)))
    {
        Scope (\_SB.PCI0.XHC.RHUB.SS02)
        {
            Device (MODM)
            {
                Name (_ADR, 0x03)  // _ADR: Address
                Name (_PR0, Package (0x01)  // _PR0: Power Resources for D0
                {
                    \_SB.PCI0.XHC.RHUB.PX03
                })
                Name (_PR2, Package (0x01)  // _PR2: Power Resources for D2
                {
                    \_SB.PCI0.XHC.RHUB.PX03
                })
                Name (_PR3, Package (0x01)  // _PR3: Power Resources for D3hot
                {
                    \_SB.PCI0.XHC.RHUB.PX03
                })
            }
        }
    }

    Scope (\_SB)
    {
        PowerResource (USBC, 0x00, 0x0000)
        {
            Method (_STA, 0, NotSerialized)  // _STA: Status
            {
                Return (0x0F)
            }

            Method (_ON, 0, NotSerialized)  // _ON_: Power On
            {
            }

            Method (_OFF, 0, NotSerialized)  // _OFF: Power Off
            {
            }
        }
    }

    Scope (\_SB.PCI0.XDCI)
    {
        OperationRegion (GENR, SystemMemory, Add (And (XDCB, 0xFF000000), 0x0010F81C), 0x04)
        Field (GENR, WordAcc, NoLock, Preserve)
        {
                ,   2, 
            CPME,   1, 
            U3EN,   1, 
            U2EN,   1
        }

        Method (_PS3, 0, NotSerialized)  // _PS3: Power State 3
        {
            Store (One, CPME)
            Store (One, U2EN)
            Store (One, U3EN)
        }

        Method (_PS0, 0, NotSerialized)  // _PS0: Power State 0
        {
            Store (Zero, CPME)
            Store (Zero, U2EN)
            Store (Zero, U3EN)
        }

        Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
        {
            Return (Zero)
        }

        Method (_PR3, 0, NotSerialized)  // _PR3: Power Resources for D3hot
        {
            Return (Package (0x01)
            {
                USBC
            })
        }
    }

    Scope (\_SB.PCI0.GLAN)
    {
        Method (_PS3, 0, NotSerialized)  // _PS3: Power State 3
        {
        }

        Method (_PS0, 0, NotSerialized)  // _PS0: Power State 0
        {
        }
    }

    Scope (\_SB.PCI0)
    {
        PowerResource (PAUD, 0x00, 0x0000)
        {
            Name (PSTA, One)
            Name (ONTM, Zero)
            Name (_STA, One)  // _STA: Status
            Method (_ON, 0, NotSerialized)  // _ON_: Power On
            {
                Store (One, _STA)
                PUAM ()
            }

            Method (_OFF, 0, NotSerialized)  // _OFF: Power Off
            {
                Store (Zero, _STA)
                PUAM ()
            }

            Method (PUAM, 0, Serialized)
            {
                If (LAnd (LEqual (^_STA, Zero), LNotEqual (\UAMS, Zero)))
                {
                    Store (Zero, ^PSTA)
                    Store (Zero, ^ONTM)
                }
                ElseIf (LNotEqual (^PSTA, One))
                {
                    Store (One, ^PSTA)
                    Store (Timer, ^ONTM)
                }
            }
        }
    }

    If (LNotEqual (\_SB.PCI0.HDAS.VDID, 0xFFFFFFFF))
    {
        Scope (\_SB.PCI0.HDAS)
        {
            Method (PS0X, 0, Serialized)
            {
                If (LEqual (\_SB.PCI0.PAUD.ONTM, Zero))
                {
                    Return (Zero)
                }

                Divide (Subtract (Timer, \_SB.PCI0.PAUD.ONTM), 0x2710, , Local0)
                Add (AUDD, VRRD, Local1)
                If (LLess (Local0, Local1))
                {
                    Sleep (Subtract (Local1, Local0))
                }
            }

            Name (_PR0, Package (0x01)  // _PR0: Power Resources for D0
            {
                \_SB.PCI0.PAUD
            })
        }
    }

    Scope (\_SB.PCI0.I2C1)
    {
        Method (_INI, 0, NotSerialized)  // _INI: Initialize
        {
            If (LAnd (LEqual (\EMOD, One), LGreaterEqual (\OSYS, 0x07DF)))
            {
                If (CondRefOf (\_SB.MODS))
                {
                    CopyObject (\_SB.PCI0.I2C1.TPL1.TD_Z, \_SB.PCI0.I2C1.TPL1.TD_P)
                }
            }
            ElseIf (CondRefOf (\_SB.PCI0.I2C1.PXTC))
            {
                CopyObject (\_SB.PCI0.I2C1.TPL1.TD_X, \_SB.PCI0.I2C1.TPL1.TD_P)
            }
        }

        Method (PS0X, 0, Serialized)
        {
            \_SB.SGOV (0x02040017, Zero)
            Sleep (0x015E)
            \_SB.SGOV (0x02040017, One)
            Sleep (0x78)
        }

        Method (PS3X, 0, Serialized)
        {
        }

        PowerResource (PXTC, 0x00, 0x0000)
        {
            Method (_STA, 0, NotSerialized)  // _STA: Status
            {
                If (LEqual (\EMOD, One))
                {
                    Return (One)
                }
                Else
                {
                    Return (PSTA ())
                }
            }

            Method (_ON, 0, NotSerialized)  // _ON_: Power On
            {
                If (LEqual (\EMOD, One)) {}
                Else
                {
                    PON ()
                }
            }

            Method (_OFF, 0, NotSerialized)  // _OFF: Power Off
            {
                If (LEqual (\EMOD, One)) {}
                Else
                {
                    POFF ()
                }
            }
        }

        Name (ONTM, Zero)
        Method (PSTA, 0, NotSerialized)
        {
            Return (Zero)
        }

        Method (PON, 0, NotSerialized)
        {
            \_SB.SGOV (0x02040017, One)
            Store (Timer, ONTM)
            \_SB.SGRA (0x02040007, One)
        }

        Method (POFF, 0, NotSerialized)
        {
            \_SB.SGRA (0x02040007, Zero)
            \_SB.SGOV (0x0201000E, Zero)
            \_SB.SGOV (0x02040017, Zero)
            Store (Zero, ONTM)
        }

        Scope (TPL1)
        {
            Name (TD_P, Package (0x00) {})
            Name (TD_X, Package (0x01)
            {
                \_SB.PCI0.I2C1.PXTC
            })
            Name (TD_Z, Package (0x01)
            {
                \_SB.MODS
            })
            Alias (IC1D, TD_D)
            Alias (\_SB.PCI0.I2C1.ONTM, TD_C)
            Method (PS0X, 0, Serialized)
            {
                If (LEqual (TD_C, Zero))
                {
                    Return (Zero)
                }

                Divide (Subtract (Timer, TD_C), 0x2710, , Local0)
                Add (TD_D, VRRD, Local1)
                If (LLess (Local0, Local1))
                {
                    Sleep (Subtract (Local1, Local0))
                }
            }

            Method (PS3X, 0, Serialized)
            {
            }

            Method (_PR0, 0, NotSerialized)  // _PR0: Power Resources for D0
            {
                If (LEqual (_STA (), 0x0F))
                {
                    Return (TD_P)
                }
                Else
                {
                    Return (Package (0x00) {})
                }
            }

            Method (_PR3, 0, NotSerialized)  // _PR3: Power Resources for D3hot
            {
                If (LEqual (_STA (), 0x0F))
                {
                    Return (TD_P)
                }
                Else
                {
                    Return (Package (0x00) {})
                }
            }

            Method (_PS0, 0, NotSerialized)  // _PS0: Power State 0
            {
                PS0X ()
            }

            Method (_PS3, 0, NotSerialized)  // _PS3: Power State 3
            {
                PS3X ()
            }
        }
    }

    Scope (\_GPE)
    {
        Method (AL6F, 0, NotSerialized)
        {
        }
    }

    If (LEqual (\EMOD, One))
    {
        Scope (\_SB)
        {
            Name (GBPS, Zero)
            PowerResource (MODS, 0x00, 0x0000)
            {
                Method (_STA, 0, NotSerialized)  // _STA: Status
                {
                    If (LGreaterEqual (OSYS, 0x07DF))
                    {
                        Return (GBPS)
                    }

                    Return (Zero)
                }

                Method (_ON, 0, NotSerialized)  // _ON_: Power On
                {
                    If (LGreaterEqual (OSYS, 0x07DF))
                    {
                        If (And (RCG0, 0x02))
                        {
                            If (LEqual (\_SB.PCI0.XHC.RHUB.CMSA (), Zero))
                            {
                                \_SB.PCI0.XHC.RHUB.CMON ()
                            }
                        }

                        \_SB.PCI0.SAT0.PRT0.SPON ()
                        \_SB.PCI0.SAT0.PRT1.SPON ()
                        \_SB.PCI0.SAT0.PRT2.SPON ()
                        \_SB.PCI0.I2C1.PON ()
                        Store (One, GBPS)
                    }
                }

                Method (_OFF, 0, NotSerialized)  // _OFF: Power Off
                {
                    If (LGreaterEqual (OSYS, 0x07DF))
                    {
                        If (And (RCG0, 0x02))
                        {
                            If (LEqual (\_SB.PCI0.XHC.RHUB.CMSA (), One))
                            {
                                \_SB.PCI0.XHC.RHUB.COFF ()
                            }
                        }

                        \_SB.PCI0.SAT0.PRT0.SPOF ()
                        \_SB.PCI0.SAT0.PRT1.SPOF ()
                        \_SB.PCI0.SAT0.PRT2.SPOF ()
                        \_SB.PCI0.I2C1.POFF ()
                        Store (Zero, GBPS)
                    }
                }
            }
        }
    }
}

